# -*- coding: utf-8 -*-
# (C) Copyright (C) 2012, 2013 Pablo Angulo
# This file is part of karakolas <karakolas.org>.

# karakolas is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as 
# published by the Free Software Foundation, either version 3 of the 
# License, or (at your option) any later version.

# karakolas is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU Affero General Public 
# License along with karakolas.  If not, see 
# <http://www.gnu.org/licenses/>.

#########################################################################

import os
import os.path
import subprocess
from encodings import codecs
import datetime
from collections import defaultdict
import re

def index():
    redirect(URL(c='default', f='index'))

@auth.requires_membership(grupo_del_productor(request.vars.pedir_a))
def nuevo_pedido():
    form = SQLFORM(db.pedido)
    iproductor = int(request.vars.pedir_a)
    productor  = db.productor[iproductor]
    texto = P(H2(T('Instrucciones para pedir a %s'%productor.nombre)),
              XML(productor.info_pedido))
    form.vars.productor = int(request.vars.pedir_a)
    form.vars.abierto = True
    form.vars.fecha_activacion = datetime.date.today()

    if form.accepts(request.vars, session):#, dbio=False):
        pid = form.vars.id #= db.pedido.insert(**dict(form.vars))
        mueve_productos_al_pedido(pid)        
        for row in db(db.grupoXred.red==productor.grupo).select(db.grupoXred.grupo):
            db.proxy_pedido.update_or_insert(
                    (db.proxy_pedido.grupo==row.grupo) &
                    (db.proxy_pedido.pedido==pid),
                       grupo=row.grupo, pedido=pid,
                       fecha_reparto=form.vars.fecha_reparto)
        redirect(URL(c='productores',
                     f='productos', 
                     vars=dict(pedido=form.vars.id, productor=iproductor)))
    elif form.errors:
        response.flash = 'form has errors'
    else:
        response.flash = 'please fill the form'
    return dict(texto=texto,
                 nuevo_pedido=form)    

@auth.requires_membership(grupo_del_pedido(request.vars.pedido))
def edita_pedido():
    ipedido = int(request.vars.pedido)
    igrupo = db.productor( db.pedido(ipedido).productor).grupo
    return dict(form=crud.update(db.pedido, ipedido, 
                                 next=URL(f='gestion_pedidos', vars=dict(grupo=igrupo))),
                 pedido=ipedido)

@auth.requires_membership('admins_%s'%request.vars.grupo)
def aceptar_productos_coordinados():
    try:
        ipedido    = int(request.vars.pedido)
        pedido     = db.pedido[ipedido]
        iproductor = pedido.productor
        igrupo     = int(request.vars.grupo)
    except:
        response.flash = T('Problema con el número de pedido')
#        return 'KeyError: ', request
        redirect(URL(f='gestion_pedidos', vars=dict(grupo=igrupo)))

    #Nec por si el admin de la red introduce cambios despues de abrir el pedido
    activa_productos_coordinados(ipedido, igrupo)

    rs = db((db.mascara_producto.grupo==igrupo) &
            (db.mascara_producto.productoXpedido==db.productoXpedido.id) &
            (db.productoXpedido.pedido==ipedido) &
            (db.productoXpedido.producto==db.producto.id)) \
         .select(db.mascara_producto.ALL, 
                 db.producto.ALL,
                 db.productoXpedido.ALL)

    p2extra = dame_valores_extra(ipedido)
    
    form = FORM(TABLE(TR(TD('Producto'), TD('Precio'), TD('Aceptar el producto')),
                  *[TR(TD(A(row.producto.nombre, 
                            SPAN(row.producto.descripcion, TAG.br(), 
                                 db.categorias_productos(row.producto.categoria).nombre, 
                                 TAG.br(), 'Precio base: %s'%row.productoXpedido.precio_base, 
                                 UL(*[LI(item) for item in p2extra[row.producto.id]])), 
                            _href='#', _class='tooltip')
                  
                       ),
                       TD(SPAN(row.productoXpedido.precio_final)), 
                       TD(INPUT(_type='checkbox', _name='aceptado_%d'%row.mascara_producto.id,
                                value=row.mascara_producto.aceptado)
) ) 
                       for row in rs]),
              INPUT(_value=T('Enviar'), _type='submit', _name='submit'))
    if request.vars.submit:
        ms = db((db.mascara_producto.productoXpedido==db.productoXpedido.id) &
                (db.productoXpedido.pedido==ipedido) &
                (db.mascara_producto.grupo==igrupo)) \
             .select(db.mascara_producto.id)
        todos   = [row.id for row in ms]
        db(db.mascara_producto.id.belongs(todos)).update(aceptado=False)
        activar = [int(k[9:]) for k in request.vars if k.startswith('aceptado_')]        
        db(db.mascara_producto.id.belongs(activar)).update(aceptado=True)
        session.flash = T('Se han aceptado los productos del pedido de %s que has marcado')%db.productor[iproductor].nombre
        redirect(URL(f='gestion_pedidos', vars=dict(grupo=igrupo)))

    return dict(validar = form)
    if request.vars.submit:
        marcados = {}
        update_is_good = True
        for k,v in request.vars.iteritems():
#            if 'prod_' in k:
            if k.startswith('prod_'):
                try:
                    _, sp = k.split('_')
                    p = int(sp)
                    precio = float(request.vars['precio_%s'%sp].replace(',','.'))
                    marcados[p] = precio
                except ValueError:      
                    response.flash = 'El precio de "%s" no se entiende'%db.producto(p).nombre
                    update_is_good = False
        if update_is_good:
            for r in db(db.productoXpedido.pedido == pedido)\
                      .select(db.productoXpedido.id, db.productoXpedido.producto):
                      if r.producto not in marcados:
                          del db.productoXpedido[r.id]
                          db.producto[r.producto].update_record(activo = False)

#            db(db.productoXpedido.pedido == pedido).delete()
#            db(db.producto.id>0).update(activo = False)
            antiguos = [r.producto for r in db(db.productoXpedido.pedido == pedido)\
                                           .select(db.productoXpedido.producto)]
            for pid, precio in marcados.iteritems():
                if pid in antiguos:
                    db.productoXpedido(pedido=ipedido, producto=pid)\
                            .update_record(precio=precio)
                    db.producto(pid).update_record(precio=precio, activo=True)                
                else:
                    db.productoXpedido.insert(pedido=ipedido, producto=pid,
                                              precio=precio)
                    db.producto(pid).update_record(precio=precio, activo=True)
            #Si esta relleno el campo de nuevo producto:
            if request.vars.new_producto_nombre and request.vars.new_producto_precio:
                nombre = request.vars.new_producto_nombre
                #TODO: Si no es un float no te rompas
                precio = float(request.vars.new_producto_precio.replace(',', '.'))
                granel = bool(request.vars.new_producto_granel)
                producto = db.producto(nombre=nombre)
                if producto:    #si el producto ya existe
                    producto.update_record(precio=precio, activo=True, granel=granel)
                    id = producto.id
                    db((db.productoXpedido.pedido == pedido) &
                       (db.productoXpedido.producto == id)).delete()
                else:
                    id = db.producto.insert(nombre = nombre,
                                            precio = precio,
                                            granel = granel,
                                            activo = True,
                                            productor = productor)
                db.productoXpedido.insert(pedido=ipedido, producto=id,
                                          precio=precio)
                productos_posibles = db(db.producto.productor==productor)\
                                     .select(db.producto.ALL)
            session.flash = T('Los productos del pedido %s han sido actualizados'%pedido)
            redirect(URL(f='gestion_pedidos', args=['abiertos'], vars=dict(grupo=igrupo)))
    if db(db.productoXpedido.pedido==pedido).select():
        producto_activo = lambda p:bool(db.productoXpedido(pedido=ipedido,producto=p))
        precio_producto = lambda p:db.productoXpedido(pedido=ipedido, producto=p).precio
    else:
        producto_activo = lambda p:db.producto(p).activo
        precio_producto = lambda p:db.producto(p).precio

    form = FORM(TABLE(TR(TD('Producto'), TD('Precio'), TD('Usar el producto para este pedido')),
                      *[TR(TD(row.nombre), 
                           TD(INPUT(_name='precio_%d'%row.id,
                                    value=precio_producto(row.id))), 
                           TD(INPUT(_type='checkbox', _name='prod_%d'%row.id,
                                    value=producto_activo(row.id))
) ) 
                       for row in productos_posibles if producto_activo(row.id)]),
                H3('Añadir producto para el productor %s'%productor.nombre),
                TABLE(TR(TH('Nombre'), TH('Precio'), TH('Granel')),
                      TR(INPUT(_name='new_producto_nombre',
                               _id='new_producto_nombre',
                               _autocomplete="off",
                               _onkeyup="ajax('sugiere_productos',"
                                         "['new_producto_nombre', 'no_productor'],"
                                         "'sugerencias');"),
                         INPUT(_name='new_producto_precio',
                               _id='new_producto_precio'),
                         INPUT(_name='new_producto_granel', _type='checkbox',
                               _value='usar'))),
                INPUT(_type='submit', _name='submit', 
                      _value=T('Activar los productos marcados')), 
                INPUT(_type='hidden', _name='no_productor', _value='%d'%productor.id), 
                _method='post' )
            
    return dict(pedido=pedido,
                elige_productos=form)

#TODO: ya no es necesaria
def sugiere_productos():
    texto   = request.vars.new_producto_nombre
    iproductor = int(request.vars.no_productor)
    if not texto or len(texto)<3: return '...'
    pattern = '%' + texto.lower() + '%'
    rows    = db(db.producto.nombre.lower().like(pattern) &
                 (db.producto.productor==iproductor)      &
                 (db.producto.activo==False))\
              .select(db.producto.nombre, db.producto.precio_base)
    return DIV(*[DIV(row.nombre,
                _onclick="jQuery('#new_producto_nombre').val('%s');jQuery('#new_producto_precio').val('%.2f');"% (row.nombre,float(row.precio)),
                _onmouseover="this.style.backgroundColor='yellow'",
                _onmouseout="this.style.backgroundColor='white'"
                ) for row in rows])


#OBSOLETA: borrar
#@auth.requires_login()
#def info_pedido():
#    try:
#        pedido    = int(request.args(0))
#    except:
#        redirect(URL(c='default', f='index'))
#    return dict(productos=db((db.productoXpedido.pedido==pedido) &
#                      (db.productoXpedido.producto==db.producto.id)
#                     ).select(db.producto.ALL),
#                pedido=db.pedido[pedido])

@auth.requires_membership('admins_%s'%request.vars.grupo)
def gestion_pedidos():
    igrupo = int(request.vars.grupo)
    tp = request.vars.tipo_pedidos
    
#    nuevo_pedido = A('Nuevo pedido', _href=URL(f='nuevo_pedido'))
#    nuevo_pedido = SQLFORM(db.pedido)
#    if nuevo_pedido.accepts(request.vars, session, dbio=False):
#        nuevo_pedido.vars.id = db.pedido.insert(**dict(form.vars))
#    elif nuevo_pedido.errors:
#        response.flash = 'form has errors'
    nuevo_pedido = FORM(FIELDSET(T('Abrir nuevo pedido de: '),
                 SELECT(OPTION('Elige un productor', _value=-1),
                        *[OPTION(p.nombre, _value=p.id)
                          for p in db((db.productor.id>0) &
                                      (db.productor.grupo==igrupo))\
                                    .select(db.productor.nombre,
                                            db.productor.id)],
                        **dict(_name='productor', _id='productor'))),
                 INPUT(_type='submit', _name='submit'))
    if request.vars.submit:
        redirect(URL(c='gestion_pedidos', f='nuevo_pedido', vars={'pedir_a':request.vars.productor, 'grupo':igrupo}))

    if tp not in TIPO_PEDIDO:
        links = UL(LI(A(T('Pedidos históricos'), 
                          _href=URL(f='gestion_pedidos', 
                                    vars=dict(tipo_pedidos=PEDIDOS_HISTORICOS, grupo=igrupo)))),
                   **dict(_id='links_listas_de_pedidos'))
        pedidos_a = dame_pedidos_por_fecha(igrupo, PEDIDOS_ABIERTOS,
                                           todos_los_coordinados=True)
        pedidos_c = dame_pedidos_por_fecha(igrupo, PEDIDOS_CERRADOS,
                                           todos_los_coordinados=True)
        pedidos   = (pedidos_a, pedidos_c)
        tp = PEDIDOS_ACTIVOS
    else:
        links = UL(*[LI(A(T('Pedidos %ss')%v, 
                          _href=URL(f='gestion_pedidos', 
                                    vars=dict(tipo_pedidos=k, grupo=igrupo))))
                     for k,v in TIPO_PEDIDO.iteritems() if k!=tp],
                   **dict(_id='links_listas_de_pedidos'))
        pedidos = dame_pedidos_por_fecha(igrupo, tp,
                                           todos_los_coordinados=True)
    return dict(nuevo_pedido=nuevo_pedido, pedidos=pedidos,
                links=links, tp=tp, grupo=igrupo)

@auth.requires_membership(grupo_del_pedido(request.vars.pedido))
def cerrar_pedido():
    try:
        ipedido    = int(request.vars.pedido)
        pedido = db.pedido[ipedido]
    except:
        session.flash = T('Problema con el número de pedido. No se ha cerrado el pedido.')
#        raise Exception
        redirect(URL(c='default', f='index'))
    pedido.update_record(abierto=False)
    cantidad_total = db.item.cantidad.sum()
    rows = db((db.item.productoXpedido==db.productoXpedido.id) &
              (db.productoXpedido.producto==db.producto.id)  &
              (db.productoXpedido.pedido==ipedido)) \
           .select(cantidad_total, db.productoXpedido.producto, 
                   orderby=db.producto.categoria|db.producto.nombre,
                   groupby=db.productoXpedido.producto)
    response.flash=T('El pedido ha sido cerrado')
    return dict(pedido=pedido, igrupo=pedido.productor.grupo.id,
                totales=dict((row.productoXpedido.producto.nombre, row[cantidad_total]) 
                        for row in rows if row[cantidad_total]>0),
                comentarios=db(db.comentarioApeticion.pedido==ipedido)\
                            .select(db.comentarioApeticion.persona,
                                    db.comentarioApeticion.texto),
                productor=db.productor[pedido.productor])

#@auth.requires_membership(grupo_del_pedido(request.vars.pedido))
@auth.requires(autoriza_pedido(request.vars, perms='r'))
def vista_totales():
    try:
        ipedido    = int(request.vars.pedido)
        pedido = db.pedido[ipedido]
    except:
        session.flash = 'Problema con el número de pedido'
        redirect(URL(c='default', f='index'))
    if 'grupo' in request.vars:
        igrupo = int(request.vars.grupo)
    else:
        igrupo  = pedido.productor.grupo.id

    cantidad_total = db.item.cantidad.sum()
    precio_total = db.item.precio_total.sum()
    if db.grupo[igrupo].red:
        rows = db((db.item.productoXpedido==db.productoXpedido.id) &
                  (db.productoXpedido.pedido==ipedido)  &
                  (db.productoXpedido.producto==db.producto.id)  &
                  (db.item.grupo==db.grupoXred.grupo) &
                  (db.grupoXred.red==igrupo)) \
               .select(cantidad_total, precio_total,
                       db.productoXpedido.producto, 
                       orderby=db.producto.categoria|db.producto.nombre,
                       groupby=db.item.productoXpedido)        
    else:
        rows = db((db.item.productoXpedido==db.productoXpedido.id) &
                  (db.productoXpedido.pedido==ipedido)  &
                  (db.productoXpedido.producto==db.producto.id)  &
                  (db.item.grupo==igrupo)) \
               .select(cantidad_total, precio_total,
                       db.productoXpedido.producto,
                       orderby=db.producto.categoria|db.producto.nombre,
                       groupby=db.item.productoXpedido)
    return dict(pedido=pedido, igrupo=igrupo,
                comentarios=db(db.comentarioApeticion.pedido==ipedido)\
                            .select(db.comentarioApeticion.persona,
                                    db.comentarioApeticion.texto),
                totales=dict((row.productoXpedido.producto.nombre, 
                             (row[cantidad_total], row[precio_total]))
                        for row in rows if row[cantidad_total]))

@auth.requires_membership('admins_%s'%request.vars.grupo)
def pedidos_coordinados():
    igrupo = int(request.vars.grupo)
    q = request.vars.tipo_pedidos
    if q not in TIPO_PEDIDO:
        q = PEDIDOS_ABIERTOS
    tp = TIPO_PEDIDO[q]

    links = UL(*[LI(A(T('Pedidos %ss')%v, 
                      _href=URL(f='pedidos_coordinados', 
                                vars=dict(tipo_pedidos=k, grupo=igrupo))))
                 for k,v in TIPO_PEDIDO.iteritems() if k!=q],
               **dict(_id='links_listas_de_pedidos'))

    lista_pc = {}
    def pedido_activo(pid):
        pp = db.proxy_pedido(pedido=pid, grupo=igrupo)
        return pp and pp.activo
    for row in db(db.grupoXred.grupo==igrupo).select(db.grupoXred.red):
        pedidos = dame_pedidos_por_fecha(row.red, q)
        #TODO: Pedidos coordinados desde una superred
        lista_pc[row.red] = pedidos
    
    #Este codigo muestra todos los pedidos de redes y superredes, pero se salta
    #la estructura: si tenemos Coordi->RAL->KM, entonces KM puede aceptar un
    #pedido de la Cordi que la RAL no ha aceptado, así que no resuelve el problema
#    for red in redes_del_grupo(igrupo):
#        pedidos = dame_pedidos_por_fecha(red, q)
#        lista_pc[red] = pedidos

    return dict(links=links, lista_pc=lista_pc, tp=tp, 
                grupo=igrupo, ngrupo=db.grupo(igrupo).nombre,
                pedido_activo=pedido_activo)

@auth.requires_membership('admins_%s'%request.vars.grupo)
def edita_pedido_coordinado():
    igrupo  = int(request.vars.grupo)
    ipedido = int(request.vars.pedido)
    productor = db.productor(db.pedido(ipedido).productor)
    if productor:
        pprod = db.proxy_productor(productor=productor.id, grupo=igrupo)
        comentarios = pprod.comentarios if pprod else ''
    else:
        comentarios = ''
        
    pp = db.proxy_pedido(grupo=igrupo, pedido=ipedido)
    if pp:
        form = SQLFORM(db.proxy_pedido, pp.id, showid=False, 
                fields=['comentarios', 'fecha_reparto', 'activo'])
    else:
        form = SQLFORM(db.proxy_pedido, showid=False, 
                fields=['comentarios', 'fecha_reparto', 'activo'])
        form.vars.fecha_reparto = db.pedido(ipedido).fecha_reparto

    if form.accepts(request.vars, session):
        if pp:
            pp.update_record(comentarios=form.vars.comentarios, 
                             fecha_reparto=form.vars.fecha_reparto,
                             activo=form.vars.activo)
            ppid = pp.id
        else:
            ppid = db.proxy_pedido.insert(grupo=igrupo, pedido=ipedido,
                                          comentarios=form.vars.comentarios, 
                                          fecha_reparto=form.vars.fecha_reparto,
                             activo=form.vars.activo)

            activa_productos_coordinados(ipedido, igrupo)

        session.flash = (T('El pedido se ha activado. Ahora elige los productos que se pedirán en tu grupo.') if form.vars.activo
                         else T('El grupo %s no se une a este pedido coordinado')%
                                db.grupo[igrupo].nombre)
        redirect(URL(f='aceptar_productos_coordinados', vars=dict(grupo=igrupo, pedido=ipedido)))
#            redirect(URL(f='pedidos_coordinados', vars=dict(grupo=igrupo)))
    elif form.errors:
        response.flash = 'form has errors'

    return dict(edit_form = form, comentarios=comentarios)


@auth.requires(auth.has_membership(role='admins_%s'%request.vars.grupo) or
               auth.has_membership(role='miembros_%s'%request.vars.grupo))
def ver_peticion_unidad():
    try:
        igrupo = int(request.vars.grupo)
        grupo  = db.grupo(igrupo)
        ipedidos = [int(i) for i in request.vars.pedidos.split(',')]
        unidad = int(request.vars.unidad)
    except:
        session.flash = T('Problema con la URL')
        redirect(URL(f='gestion_pedidos', vars=dict(grupo=igrupo)))
    personas = [row.persona for row in
                db((db.personaXgrupo.grupo==igrupo) &
                   (db.personaXgrupo.unidad==unidad)) \
                .select(db.personaXgrupo.persona)]

    gran_total = 0
    tablas = []
    for ipedido in ipedidos:
        items = db((db.item.grupo==igrupo)  &
                   (db.item.unidad==unidad) &
                   (db.item.productoXpedido==db.productoXpedido.id) &
                   (db.productoXpedido.pedido==ipedido) &
                   (db.productoXpedido.producto==db.producto.id)) \
                .select(db.producto.id, 
                        db.item.cantidad,
                        db.item.precio_total)
        items_d = dict((row.producto.id, 
                        (row.item.cantidad, row.item.precio_total)) 
                       for row in items)
        peticiones = db((db.peticion.persona.belongs(personas)) &
                        (db.peticion.productoXpedido==db.productoXpedido.id) &
                        (db.productoXpedido.pedido==ipedido) &
                        (db.productoXpedido.producto==db.producto.id)) \
                    .select(db.producto.id,
                            db.peticion.cantidad,
                            db.peticion.persona)
        peticiones_d = dict(((row.producto.id, row.peticion.persona), 
                              row.peticion.cantidad) 
                             for row in peticiones)
        productos = ordena_productos([r.producto.id for r in items] +
                                     [r.producto.id for r in peticiones])
        productos_d = db(db.producto.id.belongs(productos)) \
                       .select(db.producto.id, db.producto.nombre) \
                       .as_dict()
        precios_d = db(db.productoXpedido.producto.belongs(productos)) \
                       .select(db.productoXpedido.producto, db.productoXpedido.precio_final) \
                       .as_dict(key='producto')

        total = 0
        ths = [TH(T('Producto')), TH(T('Precio unitario')) ]
        ths += [TH(representa_usuario_2(p)) for p in personas]
        ths.append(TH(T('Cantidad total')))
        ths.append(TH(T('Precio total')))
        trs = []
        for p in productos:
            tds =  [TD(productos_d[p]['nombre']), TD(precios_d[p]['precio_final'])]
            tds += [TD(peticiones_d.get((p, pid), 0)) for pid in personas]
            cantidad, precio_total = items_d.get(p,(0,0))
            #TODO: si no es igual a la suma de las peticiones, ponlo en rojo
            cantidad_p = sum( peticiones_d.get((p, pid), 0) for pid in personas )
            tds.append(TD(cantidad, ' ',
                       SPAN(cantidad_p, _class='peticion_no_satisfecha') 
                        if cantidad!=cantidad_p else ''))
            tds.append(TD(precio_total ))
            trs.append(TR(tds))
            total += precio_total
        tabla = TABLE(THEAD(TR(ths)), trs)
        tablas.append((ipedido, tabla, total))
        gran_total += total
    return dict(unidad=unidad, tablas=tablas, pedido=ipedido, gran_total=gran_total)

@auth.requires(auth.has_membership(role='admins_%s'%request.vars.grupo) or
               auth.has_membership(role='miembros_%s'%request.vars.grupo))
def cobro():
    try:
        igrupo = int(request.vars.grupo)
        grupo  = db.grupo(igrupo)
#        ipedidos = [int(i) for i in request.vars.pedidos.split(',')]

        fecha = request.vars.fecha_reparto
        dia,mes,ano = fecha.split('-')
        import datetime
        fecha_reparto = datetime.date(int(ano),int(mes),int(dia))
    except:
        session.flash = T('Problema con la URL')
        redirect(URL(f='gestion_pedidos', 
                     vars=dict(tipo_pedidos=PEDIDOS_ABIERTOS, grupo=igrupo)))

    repartos, repartosc = pedidos_del_dia(fecha_reparto, igrupo)
    ipedidos = [row['id'] for row in repartos.as_list()+repartosc.as_list()]

    us = db((db.personaXgrupo.grupo==igrupo)) \
                .select(db.personaXgrupo.unidad, distinct=True,
                        orderby=db.personaXgrupo.unidad)
    unidades = [row.unidad for row in us]
    return dict(unidades=unidades, pedidos=ipedidos, 
                 grupo=igrupo, fecha_reparto=fecha_reparto)
    
    
    
############# Seccion informes ##########################
#########################################################

#def cambiar_al_directorio_base(v=1):
#    _, t= os.path.split(os.getcwd())
#    if   t=='web2py':
#        os.chdir(os.path.join('applications', request.application))
#    elif t=='informes':
#        os.chdir(os.path.join('..', '..'))
#    elif t!=request.application:
#        raise Exception, 'No se pudo establecer la ruta para almacenar los informes: %s %s'%(t, os.getcwd())
#
#def volver_del_directorio_base(v=1):
#    return
#    _, t= os.path.split(os.getcwd())
#    if t=='informes':
#        os.chdir(os.path.join('..', '..'))
#        _, t= os.path.split(os.getcwd())
#    if   t==request.application:
#        os.chdir(os.path.join('..', '..'))

@auth.requires(auth.has_membership(role='admins_%s'%request.vars.grupo) or
               auth.has_membership(role='miembros_%s'%request.vars.grupo))
def lista_informes():
    igrupo = int(request.vars.grupo)
    grupo  = db.grupo(igrupo)
    try:
        fecha = request.vars.fecha_reparto
        dia,mes,ano = fecha.split('-')
        import datetime
        fecha_reparto = datetime.date(int(ano),int(mes),int(dia))
    except:
        session.flash = T('Problema con la URL')
        redirect(URL(f='gestion_pedidos', 
                     vars=dict(tipo_pedidos=PEDIDOS_ABIERTOS, grupo=igrupo)))

    for k,v in request.vars.iteritems():
        if k.startswith('del_'):
            id = int(k[4:])
            rutapdf = db.informe[id].ruta
            #cambiar_al_directorio_base()
            wd = os.path.join(os.getcwd(), 'applications', request.application, 'static', 'informes')
            try:
                os.remove(os.path.join(wd, rutapdf))
            except OSError:
                pass #if there was an error on generation, file is not there
            del db.informe[id]
            #volver_del_directorio_base()

#            return (k[4:],v)
    links_a_informes = db((db.informe.fecha_reparto==fecha_reparto) &
                          (db.informe.grupo==igrupo)) \
                       .select(db.informe.ALL, orderby=~db.informe.fecha_generacion)
#    if not links_a_informes:
#        return dict(lista_informes=P(T('Todavía no hay informes')))
    f = FORM(TABLE(TR(TD('Productores'), 
                      TD('Tipo de informe'),
                      TD('Fecha Generación'),
                      TD('Eliminar'), ),
                   *[TR(TD(', '.join(db.pedido[int(p)].productor.nombre 
                                      for p in i.pedidos)),  
                        TD(TIPOS_INFORME[i.tipo_informe]), 
                        TD(str(i.fecha_generacion)), 
#                        TD(INPUT(_value='Eliminar', _type='submit', _name='del_%s'%i.id), )
                        TD(INPUT(_value='Eliminar', _type='checkbox', _name='del_%s'%i.id), ),
                        TD(A('Ver',
                            _href=URL(os.path.join('static','informes'),
                                      i.ruta))  ))
                     for i in links_a_informes],
                     **dict(_id='lista_informes')),
            INPUT(_type='submit', _name='submit', _value='Eliminar informes seleccionados'))
    return dict(lista_informes=f, hay_informes=bool(links_a_informes))

TEMPLATE_VERTICAL = r'''\documentclass[a4paper]{article}
\usepackage[scaled=FONT_SCALE]{helvet}
\renewcommand*\familydefault{phv}
\usepackage[utf8]{inputenc}
%\usepackage[top=1cm,bottom=1cm,left=1cm,right=1cm]{geometry}
\usepackage[margin=1cm]{geometry}
\usepackage{longtable}
\usepackage{eurosym}
\usepackage[table]{xcolor}
\usepackage{soul}

\begin{document}
\rowcolors{1}{lightgray}{white}

tabla_latex
\end{document}
'''

TEMPLATE_APAISADO = r'''\documentclass[landscape, a4paper]{article}
\usepackage[scaled=FONT_SCALE]{helvet}
\renewcommand*\familydefault{phv}
\usepackage[utf8]{inputenc}
\usepackage[top=1cm,bottom=1cm,left=1cm,right=1cm]{geometry}
\usepackage{longtable}
\usepackage{eurosym}
\usepackage[table]{xcolor}
\usepackage{soul}

%\setlength{\oddsidemargin}{0in}        % default=0in
%\setlength{\textwidth}{9in}        % default=9in
\addtolength{\textwidth}{40pt}        % default=9in
\addtolength{\topmargin}{-20pt}        % default=0.20in
\addtolength{\textheight}{40pt}        % default=5.15in
\addtolength{\leftmargin}{-20pt}        % default=???

\begin{document}
\rowcolors{1}{lightgray}{white}

tabla_latex
\end{document}
'''
#Excepto por los dos primeros, no podria explicar el valor del resto
#de las constantes; las he puesto tras ensayo y error
PAGE_WIDTH       = 21.0
PAGE_HEIGHT      = 29.7
PROD_WIDTH       = 2.0
CELL_WIDTH_LARGE = 0.8
CELL_WIDTH       = 0.5
CELL_WIDTH_SHORT = 0.3
MULTIPLIER       = 1.8
#MARGIN           = 1.0
FONT_SCALE_BASE  = 0.6
FONT_SCALE_BIS   = 0.4

def tabla_totales(ipedidos, igrupo, apaisado):
    total = db.item.precio_total.sum()
    totales = db((db.item.grupo==igrupo) &
                 (db.item.productoXpedido==db.productoXpedido.id) &
                 (db.productoXpedido.pedido.belongs(ipedidos)) ) \
              .select(total, 
                      db.productoXpedido.pedido, 
                      groupby=db.productoXpedido.pedido,
                      orderby=db.productoXpedido.pedido)
    productores = [row.productoXpedido.pedido.productor  for row in totales]
    pedidos     = [p.nombre for p in productores]
    telefonos   = [str(p.telefono or '') for p in productores]
    pedidos.append('Total'); telefonos.append('')
    precios = [row[total] for row in totales]
    precios.append(sum(precios))
    #TODO: Asumo que caben en la hoja
    width = PAGE_HEIGHT if apaisado else PAGE_WIDTH
    ncols = len(ipedidos) + 1
    cell_width = width/(ncols*2)
    ls = [(r'\begin{longtable}{' + 
          ('|p{%.2fcm}'%cell_width)*ncols + '|}\n') ]
    ls.append(r'\hline %s \\'%' & '.join(pedidos))
    ls.append(r'\hline %s \\'%' & '.join(telefonos))
    ls.append(r'\hline %s \\'%' & '.join('%.2f'%p for p in precios))
    ls.append(r'\hline\end{longtable}')
    return '\n'.join(ls)


def crear_informe_completo(ipedidos, igrupo, 
                           columnas_por_tabla=20,
                           apaisado=True,
                           **kwds):
    ###Adquisicion de datos
    mapag   = mapa_grupo(igrupo)
    unidades, productos_i, cantidades_i = recoge_y_ordena_item(ipedidos, igrupo)
    personas, productos_p, cantidades_p = recoge_y_ordena_peticion(ipedidos, igrupo)

    ###Merge de los items por unidades y las peticiones por personas
    #Podria ocurrir que se asignase pedido a una unidad que no lo pidio
    #O que una persona pidiese algo pero no le llegara nada
    spersonas = set(p for (_,p,_) in personas)
    us = set(unidades)
    us.update(u for u,_,_ in personas)
    unidades = list(us)
    unidades.sort()
    u2ps = dict((u, [p for p in mapag[u] if p in spersonas]) for u in unidades)
    username = dict((id,un) for (_,id,un) in personas)

    #Puede que un producto que se pidio no llegue, o que llegue uno que se pidio 
    iproductos = set(productos_i.keys() + productos_p.keys() )

    ordered_prods = db(db.producto.id.belongs(iproductos)) \
                    .select(db.producto.id, 
                            orderby=db.producto.categoria|db.producto.nombre)
    lproductos = [(row.id, productos_i.get(row.id) or 
                           productos_p.get(row.id))
                  for row in ordered_prods]

    productos = dict(lproductos)
    productos_ids = productos.keys()

    ###Preparar las columnas, como si no fuera nec cortar la tabla en partes
    columnas  = []
#    for unidad,miembros in u2ps.iteritems():
    for unidad in unidades:
        miembros = u2ps[unidad]
        colgroup = []
        for p in miembros:
            colgroup.append(username[p])
        colgroup.append(T('Total').xml())
        colgroup.append(T('Precio').xml())
        columnas.append((unidad, T('Unidad %s').xml()%unidad, colgroup))
    ncolumnas = sum(len(colgroup) for colgroup in columnas)

    datos   = {}
    totales = {}
    gran_total = dict((unidad,Decimal()) for unidad in unidades)
    for ipedido in ipedidos:
        tabla = []
        totales_pedido = dict((unidad,Decimal()) for unidad in unidades)
        ci_pedido = cantidades_i[ipedido]
        cp_pedido = cantidades_p[ipedido]
        prods = set(ci_pedido.keys() + cp_pedido.keys())
        prods = ordena_productos(prods)

        for pid in prods:
            _, granel,precio_f = productos[pid]
            formato = '%.2f' if granel else '%d'
            fila = []
            ci_prod = ci_pedido[pid]
            cp_prod = cp_pedido[pid]
#            for unidad,miembros in u2ps.iteritems():                
            for unidad in unidades:
                miembros = u2ps[unidad]
                cantidad_ps = 0
                for p in miembros:
                    cantidad = cp_prod[p]
                    cantidad_ps += cantidad
                    fila.append(formato%cantidad if cantidad else '')
                cantidad_i = ci_prod[unidad]
                precio     = cantidad_i*precio_f
                if cantidad_i or cantidad_ps:
                    fila.append(formato%cantidad_i 
                                if (cantidad_ps==cantidad_i) else
                                (r'\st{' + formato + '} ' + formato)%(cantidad_ps, cantidad_i))
                else:
                    fila.append('')
                fila.append('%.2f'%precio if precio else '')
                totales_pedido[unidad] += precio
            tabla.append((pid, fila))

        datos[ipedido] = tabla
        totales[ipedido] = totales_pedido
        for unidad in u2ps:
            gran_total[unidad] += totales_pedido[unidad]

    ###Preparamos la tabla final
    width = PAGE_HEIGHT if apaisado else PAGE_WIDTH
    total_width = PROD_WIDTH + CELL_WIDTH*columnas_por_tabla
    scale       = width / (total_width*MULTIPLIER)
    widths =dict(product_width='%.2f'%(PROD_WIDTH*scale),  
                 normal_cell_width='%.2f'%(CELL_WIDTH*scale),  
                ) 
    ls = []
    icol_start = 0
    icol_end   = 0
    while columnas:
        cols = [columnas.pop(0)]
        lcols = len(cols[0][2])
        while columnas and (lcols + len(columnas[0][2]) <= columnas_por_tabla):
            cols.append(columnas.pop(0))
            lcols += len(cols[-1][2])
        icol_end += lcols
        #Tabla con los grupos que estan en cols
#        ls.append(r'\begin{longtable}{|p{3cm}' + '||p{.5cm}|p{1cm}'*lcols + '||}\n')
        ls.append((r'\begin{longtable}{|p{%(product_width)scm}||' + 
                   '||'.join('|'.join('p{%(normal_cell_width)scm}' for _ in range(len(colgroup)))
#                   '%s p{.7cm}|p{1cm}'%('p{0.7cm}|'*(len(colgroup) - 2) )
                            for _,_,colgroup in cols) + 
                   '||}\n')%widths)
        cabecera1   = r'\hiderowcolors\hline & %s\\'% \
                       ' & '.join(r'\multicolumn{%d}{c||}{%s}'%
                                 (len(colgroup), unidad)
                                  for _,unidad,colgroup in cols)
        cabecera2   = r'\hline & %s\\\showrowcolors '% \
                       ' & '.join(' & '.join(colgroup)
                                  for _,_,colgroup in cols)
        for ipedido in ipedidos:
            pedido = db.pedido[ipedido]
            totales_pedido = totales[ipedido]
            ls.append(r'\hline\multicolumn{%d}{|c|}{\textbf{%s}}\\'%
                      (lcols+1, pedido.productor.nombre))
            ls.append(cabecera1)
            ls.append(cabecera2)

            for pid,fila in datos[ipedido]:
                ls.append(r'\hline %s & %s \\'%(productos[pid][0].replace('%','\%'), ' & '.join(fila[icol_start:icol_end])))

            ls.append(r'\hiderowcolors\hline Total Unidad & %s\\'% \
                       ' & '.join(r'\multicolumn{%d}{c||}{%.2f}'%
                                 (len(colgroup), totales_pedido[iunidad])
                                  for iunidad,_,colgroup in cols)
                    )

        ls.append(r'\hiderowcolors\hline Gran Total Unidad & %s\\'% \
                   ' & '.join(r'\multicolumn{%d}{c||}{%.2f}'%
                             (len(colgroup), gran_total[iunidad])
                              for iunidad,_,colgroup in cols)
                )
        ls.append(r'\hline\end{longtable}')
        icol_start = icol_end
    tabla_latex         = '\n'.join(ls)
    tabla_latex_totales = tabla_totales(ipedidos, igrupo, apaisado)

    if apaisado:
        latex = TEMPLATE_APAISADO
    else:
        latex = TEMPLATE_VERTICAL
    return latex.replace('FONT_SCALE', '%.2f'%(scale*FONT_SCALE_BIS)) \
                 .replace('tabla_latex','%s'%tabla_latex + tabla_latex_totales)

def crear_informe_agrupado(ipedidos, igrupo, 
                           columnas_por_tabla=20,
                           apaisado=True,
                           **kwds):
    unidades_por_tabla = columnas_por_tabla//2
    columnas_por_tabla = unidades_por_tabla*2
    pedidos = [db.pedido[id] for id in ipedidos]
    unidades, productos, cantidades = recoge_y_ordena_item(ipedidos, igrupo)
    productos_ids = productos.keys()
    productos_ids.sort()

    width = PAGE_HEIGHT if apaisado else PAGE_WIDTH
    total_width = (PROD_WIDTH + 
                   (CELL_WIDTH + CELL_WIDTH_SHORT)*columnas_por_tabla/2)
    scale       = width / (total_width*MULTIPLIER)
    widths =dict(product_width='%.2f'%(PROD_WIDTH*scale),  
                 normal_cell_width='%.2f'%(CELL_WIDTH*scale),  
                 short_cell_width='%.2f'%(CELL_WIDTH_SHORT*scale)
                ) 
    
    from math import ceil
    ntablas      = int(ceil(float(len(unidades))/unidades_por_tabla))
    ls           = []
    for k in range(ntablas):
        lunidades    = unidades[k*unidades_por_tabla:(k+1)*unidades_por_tabla]
        nunidades    = len(lunidades)
        gran_total  = dict(zip(lunidades, [0.0]*nunidades))

        row_unidades = r'\hiderowcolors\hline & %s\\\showrowcolors '% \
                       ' & '.join(r'\multicolumn{2}{c||}{%d}'%unidad  
                                  for unidad in lunidades)
        ls.append((r'\begin{longtable}{|p{%(product_width)scm}' + 
                    '||p{%(short_cell_width)scm}|p{%(normal_cell_width)scm}'*nunidades + 
                    '||}\n')%widths)

        for pedido in pedidos:
            precios_totales = dict(zip(lunidades, [0.0]*nunidades))
            cants = cantidades[pedido.id]
            ls.append(r'\hline\multicolumn{%d}{|c|}{\textbf{%s}}\\'%(2*nunidades + 1, pedido.productor.nombre))
            ls.append(row_unidades)

            prods = ordena_productos(cants.keys())

#            for pid,peticiones in cants.iteritems():
            for pid in prods:
                peticiones = cants[pid]
                pnombre, granel, pprecio = productos[pid]
                pnombre = pnombre.replace('%','\%')
                pprecio = float(pprecio)

                if granel:
                    cs = [float(peticiones.get(unidad, 0.0)) for unidad in lunidades]
                    ls.append(r'\hline %s & '%pnombre + 
                              ' & '.join('%.1f & %.2f\\geneuro'%(c, pprecio*c) 
                                         if c>0 else ' & ' 
                                         for c in cs) +
                              r' \\')
                else:
                    cs = [float(peticiones.get(unidad, 0)) for unidad in lunidades]
                    ls.append(r'\hline %s & '%pnombre + 
                              ' & '.join('%d & %.2f\\geneuro'%(c, pprecio*c) 
                                         if c>0 else ' & ' 
                                         for c in cs) +
                              r' \\')
                for unidad,c in zip(lunidades, cs):
                    precios_totales[unidad] += c*pprecio

            for unidad in lunidades:
                gran_total[unidad] += precios_totales[unidad]

            #Totales
            ls.append(r'\hline Total & '+ 
                          ' & '.join('  & %.2f\\geneuro'%precios_totales[unidad] 
                                     for unidad in lunidades) +
                          r' \\')    
        #Grand Totales
        if len(ipedidos)>1:
            ls.append(r'\hline\multicolumn{%d}{|c|}{\textbf{%s}}\\'%(2*nunidades + 1, T('Gran Total')))
            ls.append(r'\hline %s & '%T('Gran Total')+ 
                          ' & '.join('  & %.2f\\geneuro'%gran_total[unidad] 
                                     for unidad in lunidades) +
                          r' \\')    
        ls.append(r'\hline\end{longtable}')
#        ls.append(r'\newpage')
    tabla_latex = '\n'.join(ls)
    tabla_latex_totales = tabla_totales(ipedidos, igrupo, apaisado)

    if apaisado:
        latex = TEMPLATE_APAISADO
    else:
        latex = TEMPLATE_VERTICAL
    return latex.replace('FONT_SCALE', '%.2f'%(scale*FONT_SCALE_BIS)) \
                 .replace('tabla_latex','%s'%tabla_latex + tabla_latex_totales)

def crear_informe_reparto(ipedidos, igrupo, 
                          columnas_por_tabla=20,
                          apaisado=True,
                          **kwds):
    pedidos = [db.pedido[id] for id in ipedidos]
    unidades, productos, cantidades = recoge_y_ordena_item(ipedidos, igrupo)
    productos_ids = productos.keys()
    productos_ids.sort()

    width = PAGE_HEIGHT if apaisado else PAGE_WIDTH
    total_width = (PROD_WIDTH + 
                   CELL_WIDTH_SHORT*columnas_por_tabla)
    scale       = width / (total_width*MULTIPLIER)
    widths =dict(product_width='%.2f'%(PROD_WIDTH*scale),  
                 short_cell_width='%.2f'%(CELL_WIDTH_SHORT*scale)
                ) 
    
    from math import ceil
    ntablas      = int(ceil(float(len(unidades))/columnas_por_tabla))
    ls           = []
    for k in range(ntablas):
        lunidades    = unidades[k*columnas_por_tabla:(k+1)*columnas_por_tabla]
        nunidades    = len(lunidades)

        row_unidades = r'\hiderowcolors\hline & %s\\ \showrowcolors '% \
                       ' & '.join('%d'%unidad for unidad in lunidades)
        ls.append((r'\begin{longtable}{|p{%(product_width)scm}' + 
                  '|p{%(short_cell_width)scm}'*nunidades + '|}\n')%widths)

        for pedido in pedidos:
            cants = cantidades[pedido.id]
            ls.append(r'\hline\multicolumn{%d}{|c|}{\textbf{%s}}\\'%(nunidades+1, pedido.productor.nombre))
            ls.append(row_unidades)

            prods = ordena_productos(cants.keys())

#            for pid,peticiones in cants.iteritems():
            for pid in prods:
                peticiones = cants[pid]
                pnombre, granel, _ = productos[pid]
                pnombre = pnombre.replace('%','\%')
                if granel:
                    cs = [peticiones.get(unidad, 0.0) for unidad in lunidades]
                    ls.append(r'\hline %s & '%pnombre + 
                              ' & '.join('%.1f'%c 
                                         if c>0 else ' ' 
                                         for c in cs) +
                              r' \\')
                else:
                    cs = [peticiones.get(unidad, 0) for unidad in lunidades]
                    ls.append(r'\hline %s & '%pnombre + 
                              ' & '.join('%d '%c 
                                         if c>0 else ' ' 
                                         for c in cs) +
                              r' \\')

        ls.append(r'\hline\end{longtable}')
#        ls.append(r'\newpage')
    tabla_latex = '\n'.join(ls)
    if apaisado:
        latex = TEMPLATE_APAISADO
    else:
        latex = TEMPLATE_VERTICAL
    return latex.replace('FONT_SCALE', '%.2f'%(scale*FONT_SCALE_BIS)) \
                 .replace('tabla_latex','%s'%tabla_latex)    

def crear_informe_por_grupos(ipedidos, ired, 
                             columnas_por_tabla=20,
                             apaisado=True,
                             **kwds):
    pedidos = [db.pedido[int(p)] for p in ipedidos]

    width = PAGE_HEIGHT if apaisado else PAGE_WIDTH
    total_width = (PROD_WIDTH + 
                   (CELL_WIDTH + CELL_WIDTH_LARGE)*columnas_por_tabla/2)
    scale       = width / (total_width*MULTIPLIER)
    widths =dict(product_width='%.2f'%(PROD_WIDTH*scale),  
                 normal_cell_width='%.2f'%(CELL_WIDTH*scale),  
                 large_cell_width='%.2f'%(CELL_WIDTH_LARGE*scale)
                )

    def esta_en_el_pedido(igrupo):
        return db(db.proxy_pedido.pedido.belongs(ipedidos) &
                   (db.proxy_pedido.grupo==igrupo)&
                   (db.proxy_pedido.activo==True)).count()
    grupos_id = [gid for gid in collect_groups(ired)
                   if esta_en_el_pedido(gid)]
    grupos    = [db.grupo(gid) for gid in grupos_id]
    cantidad_total = db.peticion.cantidad.sum()
    from math import ceil
    ntablas      = int(ceil(float(len(grupos))/columnas_por_tabla))
    ls           = []
    for k in range(ntablas):
        lgrupos    = grupos[k*columnas_por_tabla:(k+1)*columnas_por_tabla]
        lgrupos_id = [row.id for row in grupos]
        ngrupos    = len(lgrupos)
        row_grupos = r'\hline & %s\\'% \
                       ' & '.join(r'\multicolumn{2}{c||}{%s}'%row.nombre.replace('_', '\\_')
                                  for row in lgrupos)
#        ls.append(r'\begin{longtable}{|p{3cm}' + '||p{0.7cm}|p{1cm}'*ngrupos + '||}\n')
        ls.append((r'\begin{longtable}{|p{%(product_width)scm}' + 
                    '||p{%(large_cell_width)scm}|p{%(large_cell_width)scm}'*ngrupos + 
                    '||}\n')%widths)

        for pedido in pedidos:
            precios_totales = dict(zip(lgrupos_id, [0.0]*ngrupos))
            ls.append(r'\hline\multicolumn{%d}{|c|}{\textbf{%s}}\\'%(2*ngrupos + 1, pedido.productor.nombre))
            ls.append(row_grupos)
            for row in db(db.productoXpedido.pedido==pedido.id) \
                       .select(db.productoXpedido.ALL):
                #Si nadie ha pedido el producto, no se pone la linea
                ct = db((db.peticion.productoXpedido==db.productoXpedido.id) &
                        (db.productoXpedido.pedido==pedido)         &
                        (db.productoXpedido.producto==row.producto) ) \
                     .select(cantidad_total,
                             groupby=db.peticion.productoXpedido)
                if not ct.first() or ct.first()[cantidad_total]==0:
                    continue
                #Seguimos
                producto = db.producto[row.producto]
                pprecio  = float(row.precio_final)
                pnombre  = producto.nombre.replace('%','\%')
                granel   = producto.granel
                cantidades = {}
                for gid in lgrupos_id:
                    q = db((db.peticion.productoXpedido==row.id)   &
                           (db.peticion.persona==db.auth_user.id)  &
                           (db.personaXgrupo.persona==db.auth_user.id)  &
                           (db.personaXgrupo.grupo==gid)             &
                           (db.personaXgrupo.activo==True)  ) \
                        .select(db.peticion.cantidad)
                    cantidad = float(sum(row.cantidad or 0 for row in q))

                    cantidades[gid]      =  cantidad
                    precios_totales[gid] += cantidad*pprecio
                if granel:
                    cs = [cantidades.get(gid, 0.0) for gid in lgrupos_id]
                    ls.append(r'\hline %s & '%pnombre + 
                              ' & '.join('%.1f & %.2f\\geneuro'%(c, pprecio*c) 
                                         if c>0 else ' & ' 
                                         for c in cs) +
                              r' \\')
                else:
                    cs = [cantidades.get(gid, 0) for gid in lgrupos_id]
                    ls.append(r'\hline %s & '%pnombre + 
                              ' & '.join('%d & %.2f\\geneuro'%(c, pprecio*c) 
                                         if c>0 else ' & ' 
                                         for c in cs) +
                              r' \\')
                
            #Totales
            ls.append(r'\hline Total & '+ 
                          ' & '.join('  & %.2f\\geneuro'%precios_totales[gid] 
                                     for gid in lgrupos_id) +
                          r' \\')    
        ls.append(r'\hline\end{longtable}')
#        ls.append(r'\newpage')
    tabla_latex = '\n'.join(ls)

    if apaisado:
        latex = TEMPLATE_APAISADO
    else:
        latex = TEMPLATE_VERTICAL
    return latex.replace('FONT_SCALE', '%.2f'%(scale*FONT_SCALE_BASE)) \
                 .replace('tabla_latex','%s'%tabla_latex)    

#Lo dejo aparcado
def crear_informe_totales(ipedidos, igrupo, personas_por_columna=6):
    pedidos = [db.pedido[id] for id in ipedidos]
    cantidad_total = db.item.cantidad.sum()
    def ha_pedido(persona):
        return  db((db.item.productoXpedido==db.productoXpedido.id) &
                    (db.productoXpedido.pedido.belongs(pedidos))  &
                    (db.item.persona==persona) ).count()
    personas = [row for row in db((db.personaXgrupo.grupo==igrupo) &
                                  (db.personaXgrupo.persona==db.auth_user.id)) \
                                   .select(db.auth_user.ALL, db.personaXgrupo.unidad,
                                   orderby=db.personaXgrupo.unidad|db.auth_user.username)
                          if ha_pedido(row.auth_user.id)]
    personas_id  = [row.auth_user.id for row in personas]
    from math import ceil
    ntablas      = int(ceil(float(len(personas))/personas_por_columna))
    ls           = []
    for k in range(ntablas):
        lpersonas     = personas[k*personas_por_columna:(k+1)*personas_por_columna]
        lpersonas_id  = [row.auth_user.id for row in lpersonas]
        npersonas     = len(lpersonas)
        row_unidades = r'\hline & %s\\'% \
                       ' & '.join(r'\multicolumn{2}{l||}{%d}'%row.personaXgrupo.unidad  
                                  for row in lpersonas)
        row_personas = r'\hline & %s\\'% \
                       ' & '.join(r'\multicolumn{2}{l||}{%s}'%row.auth_user.username.replace('_', '\\_')
                                  for row in lpersonas)
        row_vacia    = r'\hline & %s\\'% \
                       ' & '.join(r'\multicolumn{2}{l||}{}' for row in lpersonas)
#        ls.append('\n\\newline\n') #lo peta ahora?
        ls.append(r'\begin{longtable}{|p{3cm}' + '||p{.7cm}|p{1cm}'*npersonas + '||}\n\hiderowcolors\n')
        ls.append(row_unidades)
        ls.append(row_personas)
        gran_total = dict(zip(lpersonas_id, [0.0]*npersonas))
        for pedido in pedidos:
            precios_totales = dict(zip(lpersonas_id, [0.0]*npersonas))
            ls.append(r'\hline\multicolumn{%d}{|c|}{\textbf{%s}}\\'%(2*npersonas + 1, pedido.productor.nombre))

            for row in db(db.productoXpedido.pedido==pedido.id) \
                       .select(db.productoXpedido.ALL):
                #Si nadie ha pedido el producto, no se pone la linea
                ct = db((db.item.productoXpedido==db.productoXpedido.id) &
                        (db.productoXpedido.pedido==pedido)         &
                        (db.productoXpedido.producto==row.producto) ) \
                     .select(cantidad_total,
                             groupby=db.item.productoXpedido)
                if not ct or not ct.first()[cantidad_total]:
                    continue
                #Seguimos
                producto = db.producto[row.producto]
                pprecio  = float(row.precio)
                pnombre  = producto.nombre.replace('%','\%')
                granel   = producto.granel
                cantidades = {}
                for pid in lpersonas_id:
                    q = db.item(productoXpedido=row.id, persona=pid)
                    cantidad = float(q.cantidad or 0) if q else 0.0
                    cantidades[pid]      =  cantidad
                    precios_totales[pid] += cantidad*pprecio

            for pid in lpersonas_id:
                gran_total[pid] += precios_totales[pid]
            ls.append(r'\hline Total & '+ 
                          ' & '.join('  & %.2f\\geneuro'%precios_totales[pid] 
                                     for pid in lpersonas_id) +
                          r' \\')    
            ls.append(row_vacia)
            ls.append(row_vacia)

        ls.append(r'\hline Gran total & '+ 
                      ' & '.join('  & %.2f\\geneuro'%gran_total[pid] 
                                 for pid in lpersonas_id) +
                      r' \\')    
        ls.append(row_vacia)
        ls.append(row_vacia)

        ls.append(r'\hline\end{longtable}')
#        ls.append(r'\newpage')
    return '\n'.join(ls)

CREAR_INFORME = {
    COBRO_DESGLOSADO:        crear_informe_completo,
    COBRO_AGRUPADO:          crear_informe_agrupado,
    REPARTO_FACIL:           crear_informe_reparto,
#    COBRO_TOTALES:           crear_informe_totales,
    DESGLOSADO_POR_GRUPOS:   crear_informe_por_grupos
}


def generar_informe(tipo_informe, ipedidos, fecha_reparto, igrupo, **kwds):
    pedidos = [db.pedido[id] for id in ipedidos]
    table_func = CREAR_INFORME[tipo_informe]

    latex_content = table_func(ipedidos, igrupo, **kwds)

    #Write tex file
    str_fecha = format_fecha(fecha_reparto)
    rutatex = 'cobro_%s_%s_%s.tex' %(fecha_reparto, 
                                     '_'.join('%s'%p.id for p in pedidos),
                                     str(datetime.datetime.now()).replace(' ','_').replace(':','.') )
    #cambiar_al_directorio_base()
#    os.chdir(os.path.join('static', 'informes'))
    outfile = codecs.EncodedFile(open(rutatex, 'w'), 'utf-8', 'utf-8')
    outfile.write(latex_content)
    outfile.close()

    wd = os.path.join(os.getcwd(), 'applications', request.application, 'static', 'informes')
    command = ['pdflatex', '-halt-on-error', '-output-directory', wd, rutatex]
#    raise Exception, (os.getcwd(), os.path.join(os.getcwd(), 'applications', request.application, 'static', 'informes')
#    , os.path.join('applications', request.application, 'static', 'informes'))
    process = subprocess.Popen(command, bufsize=-1, 
                            #Si fijo current_working_directory, se queda congelado
                            #asi que cambio el dir con os.chdir, lamentablemente
#                               cwd=wd,
#                               shell=True,
                               stdout=subprocess.PIPE, stderr=subprocess.PIPE)
    stdoutdata, stderrdata = process.communicate()
    exit_code = process.returncode
    if exit_code:
        raise Exception, latex_content
    base, _ = os.path.splitext(rutatex)
    rutapdf = base + '.pdf'
    rutaaux = base + '.aux'
    rutalog = base + '.log'
#    os.remove(rutatex)
    os.remove(os.path.join(wd, rutaaux))
    os.remove(os.path.join(wd, rutalog))
    #volver_del_directorio_base()

    db.informe.insert(tipo_informe=tipo_informe,
                      grupo=igrupo,
                      pedidos=ipedidos,
                      fecha_reparto=fecha_reparto,   ruta=rutapdf)

    
#@auth.requires_membership('admins_%s'%request.vars.grupo)
@auth.requires(auth.has_membership(role='admins_%s'%request.vars.grupo) or
               auth.has_membership(role='miembros_%s'%request.vars.grupo))
def ver_informes():
    igrupo = int(request.vars.grupo)
    grupo  = db.grupo(igrupo)
    if grupo.red:
        TIPOS_INFORME = TIPOS_INFORME_RED
    else:
        TIPOS_INFORME = TIPOS_INFORME_GRUPO

    try:
        fecha = request.vars.fecha_reparto
        dia,mes,ano = fecha.split('-')
        import datetime
        fecha_reparto = datetime.date(int(ano),int(mes),int(dia))
    except:
#        return request#, t='La fecha de reparto no está clara')
        redirect(URL(f='gestion_pedidos', 
                     vars=dict(tipo_pedidos=PEDIDOS_ABIERTOS, grupo=igrupo)))
    repartos, repartosc = pedidos_del_dia(fecha_reparto, igrupo)
    form = FORM(FIELDSET(T('Tipo de informe: '),
                 SELECT(OPTION('Elige el tipo de informe', _value=-1),
                        *[OPTION(v, _value=k)
                          for k,v in TIPOS_INFORME.iteritems()],
                        **dict(_name='tipo_informe', _id='tipo_informe'))),
                FIELDSET(T('Apaisado: '), 
                         INPUT(_type='checkbox', _name='apaisado', _class='boolean '), 
                         T('Número de columnas: '), 
                         INPUT(_name='ncolumnas', _value=10, _class='integer')),
                TABLE(  TR(TH('Productor')),
                      *([TR(TD(r.productor.nombre), 
                           TD(INPUT(_type='checkbox', _name='pedido_%d'%r.id, value=True))) 
                        for r in repartos] + 
                        [TR(TD(r.productor.nombre), 
                           TD(INPUT(_type='checkbox', _name='pedido_%d'%r.id, value=True))) 
                        for r in repartosc])),
                INPUT(_type='submit', _name='submit', value='Enviar'),
                _method='post')

    if form.accepts(request.vars, session):
        ipedidos = []
        for k,v in request.vars.iteritems():
#            if 'pedido_' in k:
            if k.startswith('pedido_'):
                _,pedido = k.split('_')
                ipedidos.append(int(pedido))
        tipo_informe = int(request.vars.tipo_informe)
        apaisado = True if request.vars.apaisado else False
        ncolumnas = int(request.vars.ncolumnas)

        generar_informe(tipo_informe, ipedidos, fecha_reparto, igrupo,
                        apaisado=apaisado,
                        columnas_por_tabla=ncolumnas)
#        CREAR_INFORME[tipo_informe](pedidos, fecha_reparto)
    elif form.errors:
        response.flash = T('Problema con la peticion de nuevo pedido')
        raise Exception, form.errors
        
    return dict(repartos=form)

NUMBER = re.compile(r'(\d+\.\d*[1-9])0*|(\d+)')

def represent_number(d):
    if d:
        gs = NUMBER.match('%.2f'%d).groups()
        if gs:
            return gs[0] or gs[1]
        return d
    return ''

js_incidencias_visto = XML('''
<script type="text/javascript">
//TODO: here
anadir_campo_visto = function(){
    var rows, j, n;
    rows = $('th[id^="row_header"]');
    for(j=0; j<rows.length; j++){
        n = rows[j].id.split('_')[2];
        $(rows[j]).append('<input type="hidden" id="row_visto_'+n+'" value="0"/>');
    }
}
activa_desactiva_fila = function(e){
    var n = e.srcElement.id.split('_')[2];
    if($('#row_visto_'+n).val()=="1"){    
        $(e.srcElement).parent().css('background', '#FFF');
        $('#row_visto_'+n).val("0");
    }else{
        $(e.srcElement).parent().css('background', '#AAA');
        $('#row_visto_'+n).val("1");
    }
}
$(document).ready(function(){
    anadir_campo_visto();
    $('th[id^="row_header"]').on('click', activa_desactiva_fila);
});

</script>
'''
)

#@auth.requires_membership(grupo_del_pedido(request.vars.pedido))
@auth.requires(autoriza_pedido(request.vars))
def incidencias():
    ipedido = int(request.vars.pedido)
    if db.pedido[ipedido].abierto:
        session.flash = T('El pedido todavía no está cerrado, no puedes resolver incidencias, pero quizá querías editar las peticiones')
        redirect(URL(f='editar_peticiones', vars=request.vars))
    if 'grupo' in request.vars:
        igrupo = int(request.vars.grupo)
        grupo  = db.grupo[igrupo]
        coordinado = True
    else:
        grupo  = db.pedido(ipedido).productor.grupo
        igrupo = grupo.id
        coordinado = False
    if grupo.red:
        response.flash = DIV(T('%s es una red, no un grupo.')%grupo.nombre, TAG.br(),
                             T('No puedes editar los pedidos de los individuos.'), TAG.br(),
                             T('¿Querías editar la cantidad que recibirá cada grupo?. Todavía no se puede.'), TAG.br(),
                             T('Por favor escribe a karakolas@cancamusa.net y dínos cómo lo harías.'))
    query_productos = ((db.productoXpedido.pedido==ipedido) &
                       (db.productoXpedido.producto==db.producto.id))
    if coordinado:
        query_productos &= query_mask(igrupo)
    productos = [row.id for row in db(query_productos) \
                        .select(db.productoXpedido.id,
                                orderby=db.producto.categoria|db.producto.nombre)]
    def row_represent(pid):
        return db.productoXpedido[pid].producto.nombre

    def data_parse(v):
        return v.replace(',','.') or ''
    unidades = [row.unidad for row in 
                db((db.personaXgrupo.grupo==igrupo) &
                   (db.personaXgrupo.activo==True)) \
                .select(db.personaXgrupo.unidad, 
                        groupby=db.personaXgrupo.unidad, 
                        orderby=db.personaXgrupo.unidad)]

    query = ((db.item.productoXpedido==db.productoXpedido.id) &
             (db.item.grupo==igrupo) &
             (db.productoXpedido.pedido==ipedido) &
             (db.productoXpedido.producto==db.producto.id) )
    if coordinado:
        query &= query_mask(igrupo)
    sheet = RWSheet(query,
                    db.item.productoXpedido,
                    db.item.unidad,
                    db.item.cantidad,
                    col_ids=unidades,
                    row_ids=productos,
                    data_represent=represent_number,
                    data_parse=data_parse,
                    col_represent=lambda s:s,
                    row_represent=row_represent,
                    col_totals=True,
                    extra_values={'grupo':igrupo},
                    )
    if sheet.accepts(request.vars):
        session.flash='El pedido de %s ha sido actualizado'%db.pedido(ipedido).productor.nombre
        redirect(URL(f='vista_totales',vars=dict(pedido=ipedido, grupo=grupo.id)))
    return dict(sheet=sheet, js_incidencias_visto=js_incidencias_visto)

######

@auth.requires(autoriza_pedido(request.vars))
def editar_peticiones():
    ipedido = int(request.vars.pedido)
    if 'grupo' in request.vars:
        igrupo = int(request.vars.grupo)
        grupo  = db.grupo[igrupo]
        coordinado = True
    else:
        grupo  = db.pedido(ipedido).productor.grupo
        igrupo = grupo.id
        coordinado = False
    if grupo.red:
        response.flash = DIV(T('%s es una red, no un grupo.')%grupo.nombre, TAG.br(),
                             T('No puedes editar los pedidos de las personas que están en los grupos que pertenecen a %s.')%grupo.nombre, TAG.br(),
                             T('¿Qué querías hacer?'), TAG.br(),
                             T('Si necesitas algo, por favor escribe a karakolas@cancamusa.net y explícanoslo.'))
    
    if not db.pedido[ipedido].abierto:
        response.flash = DIV(T('El pedido ya está cerrado.'),
                            T(' ¿estás seguro de que quieres modificar la petición de las personas en vez de resolver incidencias?'),
                            T('Entra en el menú "Gestión de pedidos y podrás acceder al link para resolver incidencias"'))
    query_productos = ((db.productoXpedido.pedido==ipedido) &
                       (db.productoXpedido.producto==db.producto.id))
    if coordinado:
        query_productos &= query_mask(igrupo)
    productos = [row.id for row in
                 db(query_productos) \
                  .select(db.productoXpedido.id,
                          orderby=db.producto.categoria|db.producto.nombre)]
    def row_represent(pid):
        return db.productoXpedido[pid].producto.nombre

    def data_parse(v):
        return v.replace(',','.') or ''
    miembros = [row.persona for row in 
                 db((db.personaXgrupo.grupo==igrupo) &
                    (db.personaXgrupo.activo==True))\
                  .select(db.personaXgrupo.persona, 
                          orderby=db.personaXgrupo.unidad)]
    
    query = ((db.peticion.productoXpedido==db.productoXpedido.id) &
             (db.productoXpedido.pedido==ipedido) &
             (db.productoXpedido.producto==db.producto.id) &
             (db.peticion.persona==db.auth_user.id) &
             (db.peticion.grupo==igrupo))
    if coordinado:
        query &= query_mask(igrupo)
    sheet = RWSheet(query,
                    db.peticion.productoXpedido,
                    db.peticion.persona,
                    db.peticion.cantidad,
                    col_ids=miembros,
                    row_ids=productos,
                    data_represent=represent_number,
                    data_parse=data_parse,
                    col_represent=lambda u:representa_usuario_3(u, grupo=igrupo),
                    row_represent=row_represent,
                    col_totals=True,
                    extra_values={'grupo':igrupo},
                    )
    if sheet.accepts(request.vars):
        peticion_a_item(ipedido, igrupo)
        session.flash='El pedido de %s ha sido actualizado'%db.pedido(ipedido).productor.nombre
        redirect(URL(f='vista_totales',vars=dict(pedido=ipedido, grupo=grupo.id)))
    return dict(sheet=sheet)


#######


@auth.requires(auth.has_membership(role='admins_%s'%request.vars.grupo) or
               auth.has_membership(role='miembros_%s'%request.vars.grupo))
def exportar_pedido():
    igrupo  = int(request.vars.grupo)
    grupo   = db.grupo(igrupo)
    ipedido = int(request.vars.pedido)
    pedido  = db.grupo(ipedido)
    
    fields  = [db.producto.nombre, db.producto.descripcion, db.producto.categoria]
    q = ((db.item.productoXpedido==db.productoXpedido.id) &
         (db.productoXpedido.producto==db.producto.id)    &
         (db.item.grupo==igrupo)                          &
         (db.productoXpedido.pedido==ipedido))

    columnas_extra_string = db((db.columna_extra_pedido.pedido==ipedido) &
                               (db.columna_extra_pedido.tipo=='string')) \
                    .select(db.columna_extra_pedido.id, db.columna_extra_pedido.nombre)
    if columnas_extra_string:
        aliases = [(row.id, db.valor_extra_string_pedido.with_alias(row.nombre))
                   for row in columnas_extra_string]
        q &= reduce(lambda q1,q2:q1&q2, 
                    [((calias.producto==db.producto.id) & 
                      (calias.columna==cid))
                     for cid, calias in aliases] )
        fields.extend(calias.valor for cid, calias in aliases)

    fields.append(db.item.cantidad.sum())
    results = db(q).select(*fields, groupby=db.producto.id)
    return dict(results=results, fields=fields)
    
#    tablen = request.args(0) or 'persona'
#    if not request.vars.keywords:
#        request.vars.keywords = '%s.id > 0'%tablen
#
#    squery  = request.vars.keywords.replace('TODAY', '%s'%datetime.date.today().isoformat())
#    groupby = request.vars.groupby
#    if groupby=='None' : groupby=None
#    tablenames = list(set(FIND_TABLE_NAMES.findall(squery)))
#    tables = [db[tablename] for tablename in tablenames]
#    fields = sum((list(t) for t in tables), [])
#    query = my_smart_query(fields, squery)
#    if groupby:
#        groupt, groupf = groupby.split('.')
#        groupby = db[groupt][groupf]
#        fields  = [groupby, db[groupt].id.count()]
#    order_index = (k for k,f in enumerate(fields) if f.type != 'id').next()
#    orderby     = fields[order_index]
#    results     = db(query).select(*fields, **dict(groupby=groupby, orderby=orderby))
#    return dict(results=results, fields=fields)


@auth.requires(auth.has_membership(role='admins_%s'%request.vars.grupo) or
               auth.has_membership(role='miembros_%s'%request.vars.grupo))
def exportar_peticiones():
    igrupo  = int(request.vars.grupo)
    grupo   = db.grupo(igrupo)
    ipedido = int(request.vars.pedido)
    pedido  = db.grupo(ipedido)
    
    res = db((db.peticion.grupo==igrupo) &
             (db.peticion.productoXpedido==db.productoXpedido.id) &
             (db.productoXpedido.pedido==ipedido))\
          .select(db.productoXpedido.producto, 
                  db.peticion.cantidad, db.peticion.persona)
    
    prods = set(row.productoXpedido.producto for row in res)
    nombres_prods = [(row.id, row.nombre)
                     for row in db((db.producto.id.belongs(prods) &
                                    (db.producto.categoria==db.categorias_productos.id)))\
                        .select(db.producto.id,db.producto.nombre,
                                orderby=db.categorias_productos.nombre|db.producto.nombre) ]
    prods_d = dict((k,j) for j,(k,_) in enumerate(nombres_prods))

    users = set(row.peticion.persona for row in res)
    usernames = [(row.id, row.first_name)
                 for row in db(db.auth_user.id.belongs(users) &
                               (db.personaXgrupo.persona==db.auth_user.id) &
                               (db.personaXgrupo.grupo==igrupo))\
                        .select(db.auth_user.id,db.auth_user.first_name,
                                orderby=db.personaXgrupo.unidad|db.auth_user.first_name) ]
    users_d = dict((k,j) for j,(k,_) in enumerate(usernames))

    peticiones = [[0]*len(users) for _ in range(len(prods))]
    for row in res:
        peticiones[prods_d[row.productoXpedido.producto]]\
                  [users_d[row.peticion.persona]] = row.peticion.cantidad
    return dict(peticiones=peticiones, usernames=usernames, nombres_prods=nombres_prods)
    
    
