# -*- coding: utf-8 -*-
# (C) Copyright (C) 2012, 2013 Pablo Angulo
# This file is part of karakolas <karakolas.org>.

# karakolas is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as 
# published by the Free Software Foundation, either version 3 of the 
# License, or (at your option) any later version.

# karakolas is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU Affero General Public 
# License along with karakolas.  If not, see 
# <http://www.gnu.org/licenses/>.

#########################################################################

## if SSL/HTTPS is properly configured and you want all HTTP requests to
## be redirected to HTTPS, uncomment the line below:
# request.requires_https(
if not request.env.web2py_runtime_gae:
    ## if NOT running on Google App Engine use SQLite or other DB
    db = DAL('sqlite://storage.sqlite') ##db##
else:
    ## connect to Google BigTable (optional 'google:datastore://namespace')
    db = DAL('google:datastore')
    ## store sessions and tickets there
    session.connect(request, response, db = db)
    ## or store session in Memcache, Redis, etc.
    ## from gluon.contrib.memdb import MEMDB
    ## from google.appengine.api.memcache import Client
    ## session.connect(request, response, db = MEMDB(Client()))

## by default give a view/generic.extension to all actions from localhost
## none otherwise. a pattern can be 'controller/function.extension'
response.generic_patterns = ['*'] if request.is_local else []
## (optional) optimize handling of static files
# response.optimize_css = 'concat,minify,inline'
# response.optimize_js = 'concat,minify,inline'

#########################################################################

from gluon.tools import Auth, Crud, Service, PluginManager, prettydate
auth = Auth(db, hmac_key=Auth.get_or_create_key())
crud, service, plugins = Crud(db), Service(), PluginManager()

## create all tables needed by auth if not custom tables
auth.settings.extra_fields['auth_user']= [
    Field('direccion','string'),
    Field('telefono','string')]
auth.define_tables(username=True)

## configure email
mail=auth.settings.mailer
#mail.settings.server = 'logging' or 'smtp.gmail.com:587'
#mail.settings.sender = 'you@gmail.com'
#mail.settings.login = 'username:password'
mail.settings.server = 'localhost:25'  # your SMTP server
mail.settings.sender = 'coopide@cancamusa.net'         # your email
mail.settings.login =  None

## configure auth policy
auth.settings.registration_requires_verification = False
auth.settings.registration_requires_approval = False
auth.settings.reset_password_requires_verification = True

## if you need to use OpenID, Facebook, MySpace, Twitter, Linkedin, etc.
## register with janrain.com, write your domain:api_key in private/janrain.key
#from gluon.contrib.login_methods.rpx_account import use_janrain
#use_janrain(auth,filename='private/janrain.key')

#########################################################################

#Mind this line: we use spanish only!!
#Atención: para simplificar, forzamos el idioma castellano
#pero es posible quitar la linea y dejar la configuración del navegador
T.force('es-es')

MESES = {1:T('Enero'), 2:T('Febrero'), 3:T('Marzo'), 4:T('Abril'), 
         5:T('Mayo'), 6:T('Junio'), 7:T('Julio'), 8:T('Agosto'), 
         9:T('Septiembre'), 10:T('Octubre'), 11:T('Noviembre'), 12:T('Diciembre'),}

AYUDA_PRODUCTOR = T('''
<h3>Abrir pedido</h3>
<p>bla bla bla</p>
<h3>Hacer el pedido</h3>
<p>bla bla bla</p>
<h3>Para el reparto</h3>
<p>bla bla bla</p>
<h3>Pagar</h3>
<p>bla bla bla</p>
''')

#TODO: Esto deberia ser configuracion de webadmin
CONTACTA_ADMIN  = T('Contacta con el administrador: pang@cancamusa.net')


db.define_table('grupo',
    Field('nombre', unique=True),
    Field('direccion'),
    Field('descripcion', 'text'),
    Field('red', 'boolean', default=False),
    Field('lista_de_espera', 'boolean', default=True),
    Field('discreto', 'boolean', default=False),
    Field('prueba', 'boolean', default=False),
    format='%(nombre)s'
    )

db.define_table('grupoXred',
    Field('grupo', db.grupo),
    Field('red', db.grupo),
    )
db.grupoXred._mysql_index_command = 'ALTER TABLE grupoXred ADD UNIQUE (grupo,red)'

def redes_del_grupo(igrupo):
    s = set()
    for row in db((db.grupoXred.grupo==igrupo)) \
                .select(db.grupoXred.red):
        s.add(row.red)
        s.update(redes_del_grupo(row.red))
    return s
    
#db.define_table('persona',
#    Field('nombre', 'string', unique=True, notnull=True),
#    Field('email', 'string', unique=True, notnull=True),
#    Field('telefono', 'integer'),    
#    Field('unidad', 'integer', notnull=True),    
#    format='%(nombre)s')
#db.persona.email.requires = IS_EMAIL()

#TODO: refactoriza
#db.define_table('unidad',
#    Field('numero', 'integer'),
#    Field('grupo', db.grupo),
#    format='%(numero)d'
#    )

db.define_table('personaXgrupo',
    Field('grupo', db.grupo),
#    Field('persona', db.persona),
    Field('persona', db.auth_user),
    Field('unidad', 'integer', notnull=True),
#    Field('unidad', db.unidad, requires=IS_IN_DB(db.unidad)),

#Las personas que se van del grupo no se borran, se desactivan 
#(para no estropear los informes antiguos)
    Field('activo', 'boolean', default=True)    
    )
db.personaXgrupo._mysql_index_command = 'ALTER TABLE personaXgrupo ADD UNIQUE (grupo, persona)'

def representa_usuario_2(uid):
    usuario = db.auth_user[uid]
    return '%s %s'%(usuario.first_name, 
                    usuario.last_name[0] if usuario.last_name else '')

def representa_usuario_3(uid, unidad=None, grupo=None):
    usuario = db.auth_user[uid]
    if not unidad:
        unidad  = db.personaXgrupo(persona=uid, grupo=grupo).unidad
    return XML('%d<br/>%s %s'%(unidad, usuario.first_name, 
                                usuario.last_name[0] if usuario.last_name else ''))

def mapa_grupo(igrupo):
    mapa = defaultdict(list)
    for row in db(db.personaXgrupo.grupo==igrupo)  \
                   .select(db.personaXgrupo.unidad, db.personaXgrupo.persona):
        mapa[row.unidad].append(row.persona)
    for v in mapa.values():
        v.sort()
    return mapa

db.define_table('personaXlistaespera',
    Field('grupo', db.grupo),
    Field('persona', db.auth_user),
    Field('fecha_de_solicitud', 'datetime'),
    Field('comentario', 'string'),
#Las personas que se van de la lisa de espera se desactivan
#asi no se pierde la antiguedad en ningun caso (por ejemplo si se incorpora por error)
#y luego se borra
    Field('activo', 'boolean', default=True)    
    )
db.personaXlistaespera._mysql_index_command = 'ALTER TABLE personaXlistaespera ADD UNIQUE (grupo, persona)'

def esta_en_red(ipersona, grupop):
    if db.personaXgrupo(persona=ipersona, grupo=grupop):
        return True
    return any(esta_en_red(ipersona, red.grupo)  
               for red in db(db.grupoXred.red==grupop) \
                   .select(db.grupoXred.grupo))

    grupos = db((db.grupoXred.red==ired) &
                (db.grupoXred.grupo==db.grupo.id)) \
               .select(db.grupo.ALL)

def collect_groups(ired):
    if db.grupo(ired).red:
        s = set()
        for subred in db((db.grupoXred.red==ired) &
                         (db.grupoXred.grupo==db.grupo.id)) \
                      .select(db.grupo.id):
            s.update(collect_groups(subred.id))
        return s
    else:
        return set((ired,))


def collect_users(ired):
    s = set()
    if db.grupo(ired).red:
        for subred in db((db.grupoXred.red==ired) &
                         (db.grupoXred.grupo==db.grupo.id)) \
                      .select(db.grupo.id):
            s.update(collect_users(subred.id))
            return s
    else:
        return set(row.id
                    for row in  db((db.personaXgrupo.grupo==ired) &
                       (db.personaXgrupo.persona==db.auth_user.id)) \
                    .select(db.auth_user.id))

db.define_table('productor',
    Field('nombre','string',notnull=True),
    Field('email', 'string'),
    Field('grupo', db.grupo, writable=False),
    #El telefono es un string pq permite agrupar las cifras, poner prefijos y de todo.
    Field('telefono', 'string'),    
    Field('direccion','string'),
    Field('descripcion','text'),
    Field('info_pedido', 'text', default=AYUDA_PRODUCTOR),
    Field('formula_precio_final', 'string', default='precio_base'),
#    Field('automatico','boolean'),
#    Field('antelacion','?'),
    format='%(nombre)s')
#db.productor.email.requires = IS_EMAIL()
db.productor._mysql_index_command = 'ALTER TABLE productor ADD INDEX (grupo, nombre)'

def grupo_del_productor(productor):
    try:
        grupo      = db.productor(productor).grupo
        return 'admins_%s'%grupo
    except:
        return 'webadmins'

def tiene_acceso_al_grupo(productor):
    try:
        grupo      = db.productor(productor).grupo
        return (auth.has_membership(role='admins_%s'%grupo) or
                 auth.has_membership(role='miembros_%s'%grupo) or
                 auth.has_membership(role='webadmins') )
    except:
        return auth.has_membership(role='webadmins')

def format_proxy(r):
    return 'Comentarios de %s a %s'%(r.grupo.nombre, r.productor.nombre)

db.define_table('proxy_productor',
    Field('productor', db.productor, requires = IS_IN_DB(db, db.productor, '%(nombre)s')),    
    Field('grupo', db.grupo, requires = IS_IN_DB(db, db.grupo, '%(nombre)s')),    
    Field('comentarios', 'text'),
    Field('aceptado', 'boolean', default=True),
    format=format_proxy)
db.proxy_productor._mysql_index_command = 'ALTER TABLE proxy_productor ADD UNIQUE (grupo, productor)'

db.define_table('categorias_productos',
    Field('nombre', 'string', unique=True),
    Field('codigo', 'integer', unique=True),
    format='%(nombre)s'
    )

db.define_table('producto',
    Field('nombre','string',notnull=True),
    Field('productor', db.productor,requires=IS_IN_DB(db,db.productor,'%(nombre)s')),#, readable=False, writable=False),
    Field('descripcion','string', requires=IS_LENGTH(2048)),
    Field('categoria', db.categorias_productos, 
          requires=IS_IN_DB(db,db.categorias_productos,'%(nombre)s',
                        error_message=T('Por favor escoje una categoría'),
                        zero=T('Por favor escoje una categoría'))),
    #El precio es el "ultimo precio activo", pero un producto tiene un precio
    #distinto en cada pedido
    #'precio_base' es el precio base, sin aplicar la formula
    Field('precio_base','decimal(9,2)',
          requires = IS_DECIMAL_IN_RANGE(-1e6,1e6,dot=',')),
    #'precio_final' es el precio despues de aplicar la formula
    Field('precio_final','decimal(9,2)',
          requires = IS_DECIMAL_IN_RANGE(-1e6,1e6,dot=',')),
    #A granel si se pueden pedir fracciones (típicamente, se vende por kg)
    #Manojos, botellas, latas, pollos... no son a granel
    Field('granel','boolean', default=False),
    Field('activo','boolean', default=True),
    Field('destacado','boolean', default=False),
    Field('temporada','boolean', default=True),
    format='%(nombre)s')
#db.producto.productor.requires = IS_IN_DB(db, db.productor, '%(nombre)s')
#db.producto.categoria.requires = IS_IN_DB(db, db.categorias_productos, '%(nombre)s')
db.producto._mysql_index_command = 'ALTER TABLE producto ADD UNIQUE (productor, nombre)'

def ordena_categorias(cats):
    '''Ordena las categorias por codigo
    '''
    #¿se puede hacer mas eficiente?
    rows = db(db.categoria.id.belongs(cats)) \
            .select(db.categoria.id,
                    orderby=db.categoria.codigo)
    return [row.id for row in rows]

def ordena_productos(prods):
    '''Ordena los productos por el orden canonico, que ahora es categoria y 
    luego nombre por orden alfabetico
    '''
    #¿se puede hacer mas eficiente?
    rows = db(db.producto.id.belongs(prods) &
              (db.producto.categoria==db.categorias_productos.id)) \
            .select(db.producto.id,
                    orderby=db.categorias_productos.codigo|db.producto.nombre)
    return [row.id for row in rows]


db.define_table('campo_extra',
    Field('productor', db.productor, requires=IS_IN_DB(db,db.productor,'%(nombre)s')),
    Field('nombre', 'string'),
    Field('valor', 'decimal(9,2)'),
    format='%(nombre)s'
    )
db.campo_extra._mysql_index_command = 'ALTER TABLE campo_extra ADD INDEX (productor, nombre)'

NOMBRES_TIPOS_COLUMNA={
    'decimal(9,2)':T('Número'),
    'string': T('Texto'), 
    'boolean':T('Valor Sí o No')
}
#TIPOS_COLUMNA=['decimal(9,2)', 'string', 'boolean']
TIPOS_COLUMNA=NOMBRES_TIPOS_COLUMNA.keys()

db.define_table('columna_extra',
    Field('productor', db.productor, requires=IS_IN_DB(db,db.productor,'%(nombre)s')),
    Field('nombre', 'string'),
    Field('tipo', 'string', requires = IS_IN_SET(TIPOS_COLUMNA)),
    format='%(productor)s: (nombre)s'
    )
db.columna_extra._mysql_index_command = 'ALTER TABLE columna_extra ADD INDEX (productor, nombre)'

#Consistencia: columna.productor==producto.productor
db.define_table('valor_extra_decimal',
    Field('columna', db.columna_extra, requires=IS_IN_DB(db,db.columna_extra,'%(nombre)s')),
    Field('producto', db.producto),
    Field('valor', 'decimal(9,2)'),
    format='%(nombre)s'
    )
db.valor_extra_decimal._mysql_index_command = 'ALTER TABLE valor_extra_decimal ADD UNIQUE (columna, producto)'

#Consistencia: columna.productor==producto.productor
db.define_table('valor_extra_string',
    Field('columna', db.columna_extra, requires=IS_IN_DB(db,db.columna_extra,'%(nombre)s')),
    Field('producto', db.producto),
    Field('valor', 'string'),
    format='%(nombre)s'
    )
db.valor_extra_string._mysql_index_command = 'ALTER TABLE valor_extra_string ADD UNIQUE (columna, producto)'

#Consistencia: columna.productor==producto.productor
db.define_table('valor_extra_boolean',
    Field('columna', db.columna_extra, requires=IS_IN_DB(db,db.columna_extra,'%(nombre)s')),
    Field('producto', db.producto),
    Field('valor', 'boolean'),
    format='%(nombre)s'
    )
db.valor_extra_boolean._mysql_index_command = 'ALTER TABLE valor_extra_boolean ADD UNIQUE (columna, producto)'

TABLAS_VALORES_EXTRA = {
    'decimal(9,2)' : db.valor_extra_decimal,
    'string': db.valor_extra_string,
    'boolean'  : db.valor_extra_boolean
}

def format_fecha(fecha):
    y = fecha.year; m = fecha.month; d = fecha.day
    return '%d-%d-%d'%(d,m,y)

def format_pedido(r):
#    return 'Pedido del %s'%r.fecha_reparto
    return 'Pedido de %s del %s'%(r.productor.nombre,
                                                 r.fecha_reparto)
db.define_table('pedido',
    Field('productor', db.productor, 
          requires = IS_IN_DB(db, db.productor, '%(nombre)s'), 
          readable=False, writable=False),
    Field('fecha_activacion', 'date', requires=IS_DATE(), 
          compute=lambda r:request.now.date),
    Field('info_cierre', 'text', default='El pedido se cierra el jueves XX de XXXXXX por la noche.'),
    Field('fecha_reparto', 'date', requires=IS_DATE()),
    #El encargado es el que abre el pedido
#    Field('encargado', db.auth_user, compute=lambda r:auth.user.id),
    Field('abierto', 'boolean', default=False),#Lo dejamos asi por si se anula a mano
#    Field('grupo_reparto', db.grupo_reparto),
#    format='Pedido de %(productor.nombre)s del %(fecha_cierre)s')
    format=format_pedido
    )
db.pedido._mysql_index_command = 'ALTER TABLE pedido ADD INDEX (productor,fecha_reparto)'

def autoriza_pedido(vars, perms = 'rwa'):
    '''...
    
    perms pueden ser read, write, admin
    '''
    try:
        if 'grupo' in request.vars:
            igrupo = int(request.vars.grupo)
        else:
            ipedido = int(request.vars.pedido)
            igrupo  = db.pedido(ipedido).productor.grupo.id
    except:
        return False
    result = (auth.has_membership(role='admins_%s'%igrupo) or
              auth.has_membership(role='webadmins') )
    if 'a' not in perms:
        result = result or auth.has_membership(role='miembros_%s'%igrupo)
    return result

db.define_table('campo_extra_pedido',
    Field('pedido', db.pedido, requires=IS_IN_DB(db,db.pedido,format_pedido)),
    Field('nombre', 'string'),
    Field('valor', 'decimal(9,2)'),
    format='%(nombre)s'
    )
db.campo_extra_pedido._mysql_index_command = 'ALTER TABLE campo_extra_pedido ADD INDEX (pedido, nombre)'

db.define_table('columna_extra_pedido',
    Field('pedido', db.pedido, requires=IS_IN_DB(db,db.pedido,format_pedido)),
    Field('nombre', 'string'),
    Field('tipo', 'string', requires = IS_IN_SET(TIPOS_COLUMNA)),
    format='%(productor)s: (nombre)s'
    )
db.columna_extra_pedido._mysql_index_command = 'ALTER TABLE columna_extra_pedido ADD INDEX (pedido, nombre)'

#Consistencia: columna.pedido.productor==producto.productor
db.define_table('valor_extra_decimal_pedido',
    Field('columna', db.columna_extra_pedido, requires=IS_IN_DB(db,db.columna_extra_pedido)),
#TODO: hacer este cambio de producto a productoXpedido
#    Field('productoXpedido', db.productoXpedido, requires=IS_IN_DB(db,db.productoXpedido)),
    Field('producto', db.producto, requires=IS_IN_DB(db,db.producto)),
    Field('valor', 'decimal(9,2)'),
    format='%(nombre)s'
    )
db.valor_extra_decimal_pedido._mysql_index_command = 'ALTER TABLE valor_extra_decimal_pedido ADD UNIQUE (columna, producto)'

#Consistencia: columna.pedido.productor==producto.productor
db.define_table('valor_extra_string_pedido',
    Field('columna', db.columna_extra_pedido, requires=IS_IN_DB(db,db.columna_extra_pedido)),
#    Field('productoXpedido', db.productoXpedido, requires=IS_IN_DB(db,db.productoXpedido)),
    Field('producto', db.producto, requires=IS_IN_DB(db,db.producto)),
    Field('valor', 'string'),
    format='%(nombre)s'
    )
db.valor_extra_string_pedido._mysql_index_command = 'ALTER TABLE valor_extra_string_pedido ADD UNIQUE (columna, producto)'

#Consistencia: columna.pedido.productor==producto.productor
db.define_table('valor_extra_boolean_pedido',
    Field('columna', db.columna_extra_pedido, requires=IS_IN_DB(db,db.columna_extra_pedido)),
#    Field('productoXpedido', db.productoXpedido, requires=IS_IN_DB(db,db.productoXpedido)),
    Field('producto', db.producto, requires=IS_IN_DB(db,db.producto)),
    Field('valor', 'boolean'),
    format='%(nombre)s'
    )
db.valor_extra_boolean_pedido._mysql_index_command = 'ALTER TABLE valor_extra_boolean_pedido ADD UNIQUE (columna, producto)'

TABLAS_VALORES_EXTRA_PEDIDO = {
    'decimal(9,2)' : db.valor_extra_decimal_pedido,
    'string': db.valor_extra_string_pedido,
    'boolean'  : db.valor_extra_boolean_pedido
}

EXTRA_PRODUCTO_2_PEDIDO = [(v, TABLAS_VALORES_EXTRA_PEDIDO[f]) 
                      for f,v in TABLAS_VALORES_EXTRA.iteritems()]

PEDIDOS_ABIERTOS   = 'abiertos'
PEDIDOS_CERRADOS   = 'cerrados'
PEDIDOS_HISTORICOS = 'historicos'
PEDIDOS_ACTIVOS = 'activos'
TIPO_PEDIDO = {PEDIDOS_ABIERTOS:T('abierto'),
               PEDIDOS_CERRADOS:T('cerrado'),
               PEDIDOS_HISTORICOS:T('histórico')}

def grupo_para_pedir(pedido):
    try:
        productor = db.pedido(pedido).productor
        grupo     = db.productor(productor).grupo
        return 'miembros_%s'%grupo
    except:
        return 'webadmins'

def grupo_del_pedido(pedido):
    try:
        productor = db.pedido(pedido).productor
        grupo     = db.productor(productor).grupo
        return 'admins_%s'%grupo
    except:
        return 'webadmins'

def puede_pedir(pedido):
    try:
        ipersona  = auth.user.id
        productor = db.pedido(pedido).productor
        grupop    = db.productor(productor).grupo
        return esta_en_red(ipersona, grupop)            
    except:
        return auth.has_membership('webadmins')

#def format_proxy_pedido(r):
#    return 'Comentarios de %s a %s'%(r.grupo.nombre, r.productor.nombre)

db.define_table('proxy_pedido',
    Field('pedido', db.pedido, requires = IS_IN_DB(db, db.pedido, format_pedido)),    
    Field('grupo', db.grupo, requires = IS_IN_DB(db, db.grupo, '%(nombre)s')),    
    Field('comentarios', 'text', default='El pedido se cierra el jueves XX de XXXXXX por la noche.'),
    Field('fecha_reparto', 'date'),
    #incluyo este campo porque puede ser interesante poner comentarios para
    #justificar por que no se activa
    Field('activo', 'boolean', default=False)
#    format=format_proxy_pedido
    )
db.proxy_pedido._mysql_index_command = 'ALTER TABLE proxy_pedido ADD UNIQUE (grupo, pedido)'

def pedidos_del_dia(fecha_reparto, igrupo):
    repartos = db((db.pedido.fecha_reparto==fecha_reparto) &
                  (db.pedido.productor==db.productor.id) &
                  (db.productor.grupo==igrupo)) \
                .select(db.pedido.ALL)
    repartosc = db((db.proxy_pedido.fecha_reparto==fecha_reparto) &
                   (db.proxy_pedido.pedido==db.pedido.id) &
                   (db.proxy_pedido.grupo==igrupo) &
                   (db.proxy_pedido.activo==True)) \
                .select(db.pedido.ALL)
    return (repartos, repartosc)
    
def dame_pedidos_por_fecha(igrupo, q, todos_los_coordinados=False):
    today = datetime.date.today()
    query_base = ((db.pedido.productor==db.productor.id) &
                  (db.productor.grupo==igrupo))
    query_c_base = ((db.proxy_pedido.pedido==db.pedido.id) &
                    (db.pedido.productor==db.productor.id) &
                    (db.proxy_productor.productor==db.productor.id) &
                    (db.proxy_productor.grupo==igrupo) &
                    (db.proxy_productor.aceptado==True) &
                    (db.proxy_pedido.grupo==igrupo)) 
    if q==PEDIDOS_ABIERTOS:
        query   = query_base & (db.pedido.abierto==True)                 
        query_c = query_c_base & (db.pedido.abierto==True) 
    elif q==PEDIDOS_CERRADOS:
        query   = query_base & ((db.pedido.abierto==False) & 
                                (db.pedido.fecha_reparto>=today))
        query_c = query_c_base & ((db.pedido.abierto==False) & 
                                  (db.pedido.fecha_reparto>=today))
    elif q==PEDIDOS_HISTORICOS:
        query   = query_base & ((db.pedido.abierto==False) & 
                                (db.pedido.fecha_reparto<today))
        query_c = query_c_base & ((db.pedido.abierto==False) & 
                                  (db.pedido.fecha_reparto<today))
    if not todos_los_coordinados:
        query_c &= (db.proxy_pedido.activo==True)
    s = db(query) \
        .select(db.pedido.ALL, db.productor.nombre, db.productor.id)
    s2 = db(query_c)  \
          .select(db.pedido.ALL, db.proxy_pedido.fecha_reparto,
                  db.productor.nombre, db.productor.id,
                  orderby=db.pedido.fecha_reparto)

    fechas = set()
    for row in s:
        fechas.add(row.pedido.fecha_reparto)
    for row in s2:
        fechas.add(row.proxy_pedido.fecha_reparto)
    pedidos = dict((f, (list(), list())) for f in fechas)
    for row in s:
        pedidos[row.pedido.fecha_reparto][0].append(row)
    for row in s2:
        pedidos[row.proxy_pedido.fecha_reparto][1].append(row)
    ls = pedidos.items()
    ls.sort(reverse=True)
    return [(format_fecha(f), rs) for f,rs in ls]

#Consistencia: pedido.productor==producto.productor
db.define_table('productoXpedido',
    Field('pedido', db.pedido, 
          requires = IS_IN_DB(db, db.pedido, format_pedido)),
    Field('producto', db.producto, 
          requires = IS_IN_DB(db, db.producto, '%(nombre)s')),
    #'precio_base' es el precio base, sin aplicar la formula
    Field('precio_base','decimal(9,2)',
          requires = IS_DECIMAL_IN_RANGE(-1e6,1e6,dot=',')),
    #'precio_final' es el precio despues de aplicar la formula
    Field('precio_final','decimal(9,2)',
          requires = IS_DECIMAL_IN_RANGE(-1e6,1e6,dot=',')),
    Field('destacado','boolean', default=False),
    )
db.productoXpedido._mysql_index_command = 'ALTER TABLE productoXpedido ADD UNIQUE (pedido, producto)'

def mueve(tabla1, valores1, tabla2, valores2):
    '''Mueve el resultado de tabla1, parametrizado con valores1 a 
    tabla2, parametrizado con valores2
    
    Deben ser tablas con los mismos campos
    Comprueba si el registro en tabla2 ya existe y en ese caso lo actualiza
    '''
    q = reduce(lambda a,b:(a & b) , 
                    [tabla1[t]==v 
                     for t,v in valores1.iteritems() ])
    ignored_fields = ['id'] + valores1.keys()
    fields = set(tabla2.fields).intersection(tabla1.fields).difference(ignored_fields)
    map = {}
    for row in db(q).select(tabla1.ALL):
        d = dict((f, row[f]) for f in fields)
        d.update(valores2)
        r = tabla2(**d)
        if r:
            map[row.id] = r.id
            r.update_record(**d)
        else:
            map[row.id] = tabla2.insert(**d)
    return map

#def add_dicts(*ds):
#    from itertools import chain
#    return dict(chain(*[d.iteritems() for d in ds]))

def mueve_productos_al_pedido(ipedido):
    '''Define los productoXpedido para un pedido, volcando todos los productos
    marcados como activos
    '''
    iproductor = db.pedido[ipedido].productor
    v1 = {'productor':iproductor}
    v2 = {'pedido':ipedido}

    smart_update(db.productoXpedido, 
                 db.productoXpedido.pedido==ipedido,
                 [{'pedido':ipedido, 'producto':r.id,
                   'precio_final':r.precio_final, 'precio_base':r.precio_base,
                   'destacado':r.destacado}
                   for r in db((db.producto.activo==True) &
                               (db.producto.productor==iproductor))\
                            .select(db.producto.id, 
                                    db.producto.precio_final, 
                                    db.producto.precio_base,
                                    db.producto.destacado)],
                ['producto', 'pedido']
                )
#    db(db.productoXpedido.pedido==ipedido).delete()
#    for row in db((db.producto.activo==True) &
#                   (db.producto.productor==iproductor))\
#                .select(db.producto.id, 
#                        db.producto.precio_final, 
#                        db.producto.precio_base):
#        db.productoXpedido.insert(pedido=ipedido, producto=row.id,
#                 precio_final=row.precio_final, precio_base=row.precio_base)

    mueve(db.campo_extra, v1, db.campo_extra_pedido, v2)
    map = mueve(db.columna_extra, v1, db.columna_extra_pedido, v2)
    for col1,col2 in map.iteritems():
        tipo = db.columna_extra[col1].tipo
        t1 = TABLAS_VALORES_EXTRA[tipo]
        t2 = TABLAS_VALORES_EXTRA_PEDIDO[tipo]
        mueve(t1, {'columna':col1}, t2, {'columna':col2})

def dame_valores_extra(ipedido):
    extra = defaultdict(list)
    for n,t in TABLAS_VALORES_EXTRA_PEDIDO.iteritems():
        extras = db((db.columna_extra_pedido.pedido==ipedido) &
                    (db.columna_extra_pedido.tipo==n) &
                    (t.columna==db.columna_extra_pedido.id)) \
                 .select(t.producto, t.valor, db.columna_extra_pedido.nombre)
        for row in extras:
            #TODO: procesa el valor (ej, Si/no en vez de True/None, o cambia punto por coma decimal)
            extra[row[t].producto].append('%s: %s'%(row.columna_extra_pedido.nombre, row[t].valor))
    return extra

db.define_table('mascara_producto',
    Field('productoXpedido', db.productoXpedido, requires = IS_IN_DB(db, db.productoXpedido)),    
    Field('grupo', db.grupo, requires = IS_IN_DB(db, db.grupo, '%(nombre)s')),
    Field('aceptado', 'boolean', default=True),
)
db.mascara_producto._mysql_index_command = 'ALTER TABLE mascara_producto ADD UNIQUE (grupo, productoXpedido)'

def query_mask(igrupo):
    '''Uso: unir con & a otra query
    
    Por ej: solo los productos del pedido que el grupo ha aceptado

    (db.productoXpedido.pedido==ipedido) & query_mask(igrupo)
    '''
    return ((db.mascara_producto.productoXpedido==db.productoXpedido.id) &
             (db.mascara_producto.grupo==igrupo) &
             (db.mascara_producto.aceptado==True))        

def activa_productos_coordinados(ipedido, igrupo):
    productos_posibles = db(db.productoXpedido.pedido==ipedido)\
                         .select(db.productoXpedido.ALL)
    for row in productos_posibles:
        if not db.mascara_producto(productoXpedido=row.id, grupo=igrupo):
            db.mascara_producto.insert(productoXpedido=row.id, grupo=igrupo, aceptado=True)


from decimal import Decimal
def compute_precio_total(r):
    if not r.cantidad:
        return Decimal(0)
    if isinstance(r.cantidad, str):
        q = r.cantidad.replace(',','.')
    else:
        q = r.cantidad
    return ((db.productoXpedido[r.productoXpedido]).precio_final)*Decimal(q)

db.define_table('item',
    Field('productoXpedido', db.productoXpedido,
          requires = IS_IN_DB(db, db.productoXpedido)),
    Field('unidad', 'integer'),
    #pensando en pedidos compartidos, donde el pedido no lleva la info del grupo
    Field('grupo', db.grupo),
    Field('cantidad', 'decimal(9,2)',
          requires = IS_EMPTY_OR(IS_DECIMAL_IN_RANGE(0,1e6,dot=',')),
          default=Decimal(0)),
    Field('precio_total', 'decimal(9,2)', compute=compute_precio_total)
    )
db.item._mysql_index_command = 'ALTER TABLE item ADD UNIQUE (grupo, productoXpedido, unidad)'
    
db.define_table('peticion',
    Field('productoXpedido', db.productoXpedido,
          requires = IS_IN_DB(db, db.productoXpedido)),
    Field('persona', db.auth_user),
    Field('grupo', db.grupo),
    Field('cantidad', 'decimal(9,2)',
          requires = IS_EMPTY_OR(IS_DECIMAL_IN_RANGE(0,1e6,dot=',')),
          default=Decimal(0)),
    Field('precio_total', 'decimal(9,2)', compute=compute_precio_total)
    )
db.peticion._mysql_index_command = 'ALTER TABLE peticion ADD UNIQUE (grupo, productoXpedido, persona)'

def peticion_a_item(ipedido, igrupo, unidad=None):
    #Borra items antiguos
    q_items = ((db.item.grupo==igrupo) &
               (db.item.productoXpedido==db.productoXpedido.id) &
               (db.productoXpedido.pedido==ipedido))
    if unidad:
        q_items &= (db.item.unidad==unidad)
    d = db(q_items) \
        .select(db.item.id)
    ls = [row.id for row in d]
    db(db.item.id.belongs(ls)).delete()

    #Nuevos items asumiendo que llegan todas las peticiones
    cantidad_total = db.peticion.cantidad.sum()
    q_pets = ((db.peticion.persona==db.auth_user.id) &
              (db.peticion.grupo==igrupo) &
              (db.personaXgrupo.persona==db.auth_user.id) &
              (db.personaXgrupo.grupo==igrupo) &
              (db.peticion.productoXpedido==db.productoXpedido.id) &
              (db.productoXpedido.pedido==ipedido))
    if unidad:
        q_pets &= (db.personaXgrupo.unidad==unidad)
    s = db(q_pets) \
        .select(cantidad_total, 
                db.personaXgrupo.unidad, 
                db.productoXpedido.id,
                groupby=db.personaXgrupo.unidad|db.productoXpedido.id)
    for row in s:
        db.item.insert(grupo=igrupo, 
                       productoXpedido=row.productoXpedido.id,
                       unidad=row.personaXgrupo.unidad,
                       cantidad=row[cantidad_total])

def recoge_y_ordena_item(ipedidos, igrupo):
    cantidades = {}
    unidades = set()
    productos  = {}
    for ipedido in ipedidos:
        rows = db((db.item.grupo==igrupo) & 
                  (db.item.productoXpedido==db.productoXpedido.id) &
                  (db.productoXpedido.pedido==ipedido) &
                  (db.productoXpedido.producto==db.producto.id) ) \
               .select(db.item.ALL, 
                       db.productoXpedido.precio_final,
                       db.producto.ALL) 
        cs = defaultdict(lambda : defaultdict(Decimal))
        for row in rows:
            if row.item.cantidad>0:
                productos[row.producto.id] = (row.producto.nombre, row.producto.granel,
                                              row.productoXpedido.precio_final)
                unidades.add(row.item.unidad)
                cs[row.producto.id][row.item.unidad] += row.item.cantidad
                
        cantidades[ipedido] = cs
    lunidades = list(unidades)
    lunidades.sort()
    return lunidades, productos, cantidades

def recoge_y_ordena_peticion(ipedidos, igrupo):
    cantidades = {}
    personas = {}
    productos  = {}
    for ipedido in ipedidos:
        rows = db((db.peticion.productoXpedido==db.productoXpedido.id) &
                  (db.productoXpedido.pedido==ipedido)         &
                  (db.peticion.persona==db.auth_user.id) & 
                  (db.peticion.grupo==igrupo) &
                  (db.personaXgrupo.persona==db.auth_user.id) & 
                  (db.personaXgrupo.grupo==igrupo) & 
                  (db.productoXpedido.producto==db.producto.id) ) \
               .select(db.peticion.cantidad, db.peticion.precio_total, 
                       db.productoXpedido.precio_final,
                       db.auth_user.id,
                       db.personaXgrupo.unidad,
                       db.producto.ALL) 
        cs = defaultdict(lambda : defaultdict(Decimal))
        for row in rows:
            if row.peticion.cantidad>0:
                productos[row.producto.id] = (row.producto.nombre, row.producto.granel,
                                              row.productoXpedido.precio_final)
                personas[(row.personaXgrupo.unidad, row.auth_user.id)] = \
                    (representa_usuario_2(row.auth_user.id))
                cs[row.producto.id][row.auth_user.id] += row.peticion.cantidad
                
        cantidades[ipedido] = cs
    lpersonas = [(u,id,un) for ((u,id), un) in personas.iteritems()]
    lpersonas.sort()
    return lpersonas, productos, cantidades

db.define_table('comentarioApeticion',
    Field('pedido', db.pedido),
    Field('persona', db.auth_user),
    Field('texto', 'text'),
    format='%(texto)s'
    )
db.comentarioApeticion._mysql_index_command = 'ALTER TABLE comentarioApeticion ADD UNIQUE (pedido, persona)'

#Por ahora no se usa...
db.define_table('comentarioAproducto',
    Field('producto', db.producto),
    Field('persona', db.auth_user),
    Field('fecha', 'datetime'),
    Field('texto', 'text'),
    )
db.comentarioAproducto._mysql_index_command = 'ALTER TABLE comentarioAproducto ADD UNIQUE (producto, persona)'

COBRO_DESGLOSADO        = 0
COBRO_AGRUPADO          = 1
REPARTO_FACIL           = 2
DESGLOSADO_POR_GRUPOS   = 3
COBRO_TOTALES           = 4
TIPOS_INFORME_GRUPO = {
    COBRO_DESGLOSADO:       T('Informe para cobro desglosado por personas'),
    COBRO_AGRUPADO:         T('Informe para cobro, agrupado por unidades'),
    REPARTO_FACIL:          T('Informe para reparto fácil'),
#    COBRO_TOTALES:          T('Precio a pagar a cada productor, por personas'),
}
TIPOS_INFORME_RED = {

    DESGLOSADO_POR_GRUPOS:  'Informe para la red, desglosado por grupos'
}
TIPOS_INFORME = dict(TIPOS_INFORME_GRUPO.items() + TIPOS_INFORME_RED.items())

db.define_table('informe',
    Field('fecha_reparto', 'date'),
    Field('grupo', db.grupo, requires = IS_IN_DB(db, db.grupo, '%(nombre)s')),    
    Field('pedidos', 'list:reference pedido'),
    Field('tipo_informe', 'integer', requires = IS_IN_SET(TIPOS_INFORME.keys())),
    Field('ruta', 'text'),
    Field('fecha_generacion', 'datetime', compute = lambda r:request.now),    
    #TODO: comentarios
    #Field('comentario', 'string'),
    )
db.informe._mysql_index_command = 'ALTER TABLE informe ADD INDEX (grupo, fecha_reparto)'

############# Actas y archivos del grupo ################
#db.define_table('fichero',
#    Field('nombre', unique=True),
#    Field('grupo', db.grupo),
#    Field('stamp', 'datetime', compute=lambda x:request.now),
#    Field('fichero', 'upload'),
#    format='%(nombre)s'
#    )

import datetime
now=datetime.datetime.now()

db.define_table('allfiles',
    Field('filename'),
    Field('filepath'),
    Field('parentpath'),
    Field('filetype'),
    Field('file','upload'),
    Field('content','text'),
    Field('datecreated','datetime',default=now),
    Field('datemodified','datetime',default=now),
    Field('filesize','integer'),
#    Field('user',db.auth_user,default=None),
    Field('grupo',db.grupo)
    )
db.allfiles._mysql_index_command = 'ALTER TABLE allfiles ADD INDEX (grupo)'

def create_mysql_indices_run_once():
    for t in db:
        try:
            if hasattr(t,'_mysql_index_command'):
                db.executesql(t._mysql_index_command)
        except:
            print 'Error creating index on table ', t
            db.rollback()

